
-- Company: NTNU
-- Engineer: Stig Fjellskaalnes 
-- 
-- Create Date:    11:26:53 10/22/2008 
-- Design Name: 
-- Module Name:    sequencer - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity sequencer is
    port (
			clk 			:	in  std_logic;
			reset 		:	in  std_logic;
			en_in 		:	in  std_logic;
			input_seq	:	in	 std_logic_vector (159 downto 0);
			en_out		:	out std_logic;
			output_seq	:	out std_logic_vector (159 downto 0)
		);
end sequencer;

architecture Behavioral of sequencer is

	component master_rom
		port (
			clk, reset,en_in	:	in std_logic;
			z						:	in std_logic_vector (9 downto 0); -- address bus
			counter				:	in std_logic_vector (4 downto 0);
			db						:	out std_logic_vector (4 downto 0) -- data bus
		);
	end component;

	type reg_input is array ((2**5)-1 downto 0) of std_logic_vector (4 downto 0);
	type states is (IDLE,MUX2_SEL,SEND_TO_MASTER,RECV_MR,MUX31_SEL,SYNC,PUSH);
	signal reg_in,reg_out	:	reg_input;
	signal sel					:	std_logic;
	signal counter_1			:	std_logic_vector (4 downto 0);
	signal counter_2			:	std_logic_vector (4 downto 0);
	signal mux31_out			:	std_logic_vector (4 downto 0);
	signal mux2_out,sync_mr	:	std_logic_vector (4 downto 0);
	signal to_master			:	std_logic_vector (9 downto 0);
	signal from_master		:	std_logic_vector (4 downto 0);
	signal en_out_mux			:	std_logic;
	signal state,next_state	:	states;


begin

	MA_R:	master_rom				-- initializing the master rom 
										-- component in the sequencer
										--	circuit
	port map(
		clk			=>	clk,
		reset			=>	reset,
		counter		=> counter_2,
		en_in			=>	en_out_mux,
--		en_out		=>	en_out_mar,
		z				=>	to_master,
		db				=> from_master
		);
	sec_run : process (clk, en_in, counter_1, counter_2)
	
	begin
	
	if (clk'event and clk = '1') then
		if (reset = '1') then
			state <= IDLE;
	
			
		elsif (en_in = '1') then
			state <= next_state;

		end if;
	end if;
	
	end process;

	output_dec: process(clk,en_in,state)
	begin
	
		if (clk'event and clk = '1') then
		
			if (reset = '1') then
				reg_in(0) <= (others => '0');
				reg_in(1) <= (others => '0');
				reg_in(2) <= (others => '0');
				reg_in(3) <= (others => '0');
				reg_in(4) <= (others => '0');
				reg_in(5) <= (others => '0');
				reg_in(6) <= (others => '0');
				reg_in(7) <= (others => '0');
				reg_in(8) <= (others => '0');
				reg_in(9) <= (others => '0');
				reg_in(10) <= (others => '0');
				reg_in(11) <= (others => '0');
				reg_in(12) <= (others => '0');
				reg_in(13) <= (others => '0');
				reg_in(14) <= (others => '0');
				reg_in(15) <= (others => '0');
				reg_in(16) <= (others => '0');
				reg_in(17) <= (others => '0');
				reg_in(18) <= (others => '0');
				reg_in(19) <= (others => '0');
				reg_in(20) <= (others => '0');
				reg_in(21) <= (others => '0');
				reg_in(22) <= (others => '0');
				reg_in(23) <= (others => '0');
				reg_in(24) <= (others => '0');
				reg_in(25) <= (others => '0');
				reg_in(26) <= (others => '0');
				reg_in(27) <= (others => '0');
				reg_in(28) <= (others => '0');
				reg_in(29) <= (others => '0');
				reg_in(30) <= (others => '0');
				reg_in(31) <= (others => '0');
				to_master <= (others => '0');
				en_out <= '0';
				sel <= '0';
				en_out_mux <= '0';
				mux31_out <= (others => '0');
				sync_mr <= (others => '0');
				mux2_out <= (others => '0');
				--from_master <= (others => '0');
				output_seq <= (others => '0');
				reg_out <= reg_in;
				counter_1 <= "00000";
				counter_2 <= "00000";

			elsif (en_in = '1') then
				case (state) is
					when IDLE =>
						reg_in(0) <= input_seq(4 downto 0);
						reg_in(1) <= input_seq(9 downto 5);
						reg_in(2) <= input_seq(14 downto 10);
						reg_in(3) <= input_seq(19 downto 15);
						reg_in(4) <= input_seq(24 downto 20);
						reg_in(5) <= input_seq(29 downto 25);
						reg_in(6) <= input_seq(34 downto 30);
						reg_in(7) <= input_seq(39 downto 35);
						reg_in(8) <= input_seq(44 downto 40);
						reg_in(9) <= input_seq(49 downto 45);
						reg_in(10) <= input_seq(54 downto 50);
						reg_in(11) <= input_seq(59 downto 55);
						reg_in(12) <= input_seq(64 downto 60);
						reg_in(13) <= input_seq(69 downto 65);
						reg_in(14) <= input_seq(74 downto 70);
						reg_in(15) <= input_seq(79 downto 75);
						reg_in(16) <= input_seq(84 downto 80);
						reg_in(17) <= input_seq(89 downto 85);
						reg_in(18) <= input_seq(94 downto 90);
						reg_in(19) <= input_seq(99 downto 95);
						reg_in(20) <= input_seq(104 downto 100);
						reg_in(21) <= input_seq(109 downto 105);
						reg_in(22) <= input_seq(114 downto 110);
						reg_in(23) <= input_seq(119 downto 115);
						reg_in(24) <= input_seq(124 downto 120);
						reg_in(25) <= input_seq(129 downto 125);
						reg_in(26) <= input_seq(134 downto 130);
						reg_in(27) <= input_seq(139 downto 135);
						reg_in(28) <= input_seq(144 downto 140);
						reg_in(29) <= input_seq(149 downto 145);
						reg_in(30) <= input_seq(154 downto 150);
						reg_in(31) <= input_seq(159 downto 155);
						sel <= '0';
						en_out <= '0';
						
					when MUX2_SEL =>
						counter_1 <= counter_1 + 1;
						case (sel) is
							when '1' => mux2_out <= sync_mr;
							when '0' => mux2_out <= reg_in(0);
							when others => mux2_out <= (others => 'Z');
						end case;
											
					when SEND_TO_MASTER =>
						sel <= '1';
						to_master (9 downto 5) <= mux2_out;
						to_master (4 downto 0) <= mux31_out;
						
					when RECV_MR =>
						sync_mr <= from_master;
				
					when MUX31_SEL =>
						
						case (counter_1) is 
							when "00001" => 
								mux31_out <= reg_in(1);
								en_out_mux <= '1';
							when "00010" => 
								mux31_out <= reg_in(2);
								en_out_mux <= '1';
							when "00011" => 
								mux31_out <= reg_in(3);
								en_out_mux <= '1';
							when "00100" => 
								mux31_out <= reg_in(4);
								en_out_mux <= '1';
							when "00101" => 
								mux31_out <= reg_in(5);
								en_out_mux <= '1';
							when "00110" => 
								mux31_out <= reg_in(6);
								en_out_mux <= '1';
							when "00111" => 
								mux31_out <= reg_in(7);
								en_out_mux <= '1';
							when "01000" => 
								mux31_out <= reg_in(8);
								en_out_mux <= '1';
							when "01001" => 
								mux31_out <= reg_in(9);
								en_out_mux <= '1';
							when "01010" => 
								mux31_out <= reg_in(10);
								en_out_mux <= '1';
							when "01011" => 
								mux31_out <= reg_in(11);
								en_out_mux <= '1';
							when "01100" => 
								mux31_out <= reg_in(12);
								en_out_mux <= '1';
							when "01101" => 
								mux31_out <= reg_in(13);
								en_out_mux <= '1';
							when "01110" => 
								mux31_out <= reg_in(14);
								en_out_mux <= '1';
							when "01111" => 
								mux31_out <= reg_in(15);
								en_out_mux <= '1';
							when "10000" => 
								mux31_out <= reg_in(16);
								en_out_mux <= '1';
							when "10001" => 
								mux31_out <= reg_in(17);
								en_out_mux <= '1';
							when "10010" => 
								mux31_out <= reg_in(18);
								en_out_mux <= '1';
							when "10011" => 
								mux31_out <= reg_in(19);
								en_out_mux <= '1';
							when "10100" => 
								mux31_out <= reg_in(20);
								en_out_mux <= '1';
							when "10101" => 
								mux31_out <= reg_in(21);
								en_out_mux <= '1';
							when "10110" => 
								mux31_out <= reg_in(22);
								en_out_mux <= '1';
							when "10111" => 
								mux31_out <= reg_in(23);
								en_out_mux <= '1';
							when "11000" => 
								mux31_out <= reg_in(24);
								en_out_mux <= '1';
							when "11001" => 
								mux31_out <= reg_in(25);
								en_out_mux <= '1';
							when "11010" => 
								mux31_out <= reg_in(26);
								en_out_mux <= '1';
							when "11011" => 
								mux31_out <= reg_in(27);
								en_out_mux <= '1';
							when "11100" => 
								mux31_out <= reg_in(28);
								en_out_mux <= '1';
							when "11101" => 
								mux31_out <= reg_in(29);
								en_out_mux <= '1';
							when "11110" => 
								mux31_out <= reg_in(30);
								en_out_mux <= '1';
							when "11111" => 
								mux31_out <= reg_in(31);
								en_out_mux <= '1';
							
							when others =>
								en_out_mux <= '0';
								mux31_out <= (others => 'Z');
						end case;

					when SYNC =>
						reg_out(conv_integer(counter_2)) <= mux2_out;
						if (counter_2 < "11111") then
							counter_2 <= counter_2 + 1;
						end if;
						
					when PUSH =>
						output_seq(4 downto 0) <= reg_out(0);
						output_seq(9 downto 5) <= reg_out(1);
						output_seq(14 downto 10) <= reg_out(2);
						output_seq(19 downto 15) <= reg_out(3);
						output_seq(24 downto 20) <= reg_out(4);
						output_seq(29 downto 25) <= reg_out(5);
						output_seq(34 downto 30) <= reg_out(6);
						output_seq(39 downto 35) <= reg_out(7);
						output_seq(44 downto 40) <= reg_out(8);
						output_seq(49 downto 45) <= reg_out(9);
						output_seq(54 downto 50) <= reg_out(10);
						output_seq(59 downto 55) <= reg_out(11);
						output_seq(64 downto 60) <= reg_out(12);
						output_seq(69 downto 65) <= reg_out(13);
						output_seq(74 downto 70) <= reg_out(14);
						output_seq(79 downto 75) <= reg_out(15);
						output_seq(84 downto 80) <= reg_out(16);
						output_seq(89 downto 85) <= reg_out(17);
						output_seq(94 downto 90) <= reg_out(18);
						output_seq(99 downto 95) <= reg_out(19);
						output_seq(104 downto 100) <= reg_out(20);
						output_seq(109 downto 105) <= reg_out(21);
						output_seq(114 downto 110) <= reg_out(22);
						output_seq(119 downto 115) <= reg_out(23);
						output_seq(124 downto 120) <= reg_out(24);
						output_seq(129 downto 125) <= reg_out(25);
						output_seq(134 downto 130) <= reg_out(26);
						output_seq(139 downto 135) <= reg_out(27);
						output_seq(144 downto 140) <= reg_out(28);
						output_seq(149 downto 145) <= reg_out(29);
						output_seq(154 downto 150) <= reg_out(30);
						output_seq(159 downto 155) <= reg_out(31);
						counter_2 <= "00000";
						en_out <= '1';
				end case;
			end if;
		end if;
	
	end process;
	
	next_state_dec: process(state,counter_1,counter_2)
	begin
		next_state <= state;
		case (state) is
			when IDLE =>
				case (counter_1) is
					when "00000" =>
						next_state <= MUX2_SEL;
					
					when others =>
						next_state <= MUX31_SEL;
					end case;
			when MUX2_SEL =>
				next_state <= SYNC;
			when SEND_TO_MASTER =>
				next_state <= RECV_MR;
			when RECV_MR =>
				next_state <= MUX2_SEL;
			when MUX31_SEL =>
				next_state <= SEND_TO_MASTER;
				
			when SYNC =>
				if (counter_2 = "11111") then
					next_state <= PUSH;
				else
					next_state <= MUX31_SEL;
				end if;
				
			when PUSH =>
				next_state <= IDLE;
		end case;
	end process;
	
	
end Behavioral;

