library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;


entity Dobbertin_ROM is
	
	port (
		
		z						:	in std_logic_vector (12 downto 0);
		clk,reset,en_in	:	in std_logic;
		db						: out std_logic_vector(12 downto 0);
		en_out				: out std_logic
	);      
end Dobbertin_ROM;

architecture rtl of Dobbertin_ROM is
begin
	process(clk,reset,en_in)
	begin
		
		if(clk'event and clk = '1') then
			if (reset = '1') then
				db <= (others => '0');
				en_out <= '0';
			elsif (en_in = '1') then
				en_out <= '1';
					db(12) <= ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(7)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(4)
					and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (
					not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(8) and  not z(7) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and z(10) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3)
					and z(2) and z(0))  or  ( not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(9) and z(8)
					and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7) and  not z(6)
					and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7)
					and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(9) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and z(7)
					and z(6) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(7) and z(6) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(6) and z(5)
					and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(4)
					and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(4) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2)
					and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(4) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(11)
					and  not z(10) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(6) and z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(7) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(4) and z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1))  or  ( not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(7)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(7) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(7) and z(6) and z(5) and z(4)
					and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and z(5) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8)
					and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(7) and  not z(6)
					and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7)
					and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7)
					and z(6) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(5)
					and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(9)
					and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and z(6)
					and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(4)
					and z(2) and z(1) and z(0))  or  (z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8)
					and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(7) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(9)
					and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(10) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7)
					and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(4)
					and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(10) and z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(4) and z(3) and z(2)
					and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(6) and z(5)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2)
					and z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(7) and z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(7) and z(5) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2)
					and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(1) and z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and z(1))  or  (z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(9)
					and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and z(7) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(9) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1)
					and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2)
					and z(1))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and  not z(9)
					and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and z(9) and  not z(8)
					and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and z(7) and  not z(6)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and z(7) and z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  (z(12) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(11) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(7) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(8) and z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(7) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7)
					and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(7) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(2)
					and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and z(1))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7)
					and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(6) and  not z(5) and z(4)
					and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and z(7) and z(6) and  not z(4) and z(3)
					and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1))  or  (z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12)
					and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(10)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(8) and  not z(7)
					and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(7) and  not z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(3) and z(2) and z(0));
					
					db(11) <= ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9)
					and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9)
					and z(8) and z(7) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5)
					and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(6) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(6) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(4) and z(2) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(6)
					and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and  not z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10)
					and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  ( not z(12) and z(10) and z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(4) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(8) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10)
					and  not z(9) and z(8) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1))  or  (z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and z(10) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and z(6)
					and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(2) and  not z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3)
					and  not z(2) and z(1))  or  (z(12) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(9) and z(8)
					and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(10) and  not z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(10) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(10) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11)
					and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(4) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4)
					and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8)
					and z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(3) and z(1))  or  (z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(12) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3)
					and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(12) and  not z(11) and  not z(10)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(6)
					and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(2) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1))  or  (z(12)
					and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  ( not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and  not z(10) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and z(9)
					and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5)
					and z(4) and z(2) and  not z(0))  or  (z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2)
					and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(0))  or  (z(11) and z(10) and z(9) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(2) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2)
					and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(11) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and z(4) and z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (
					not z(11) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (z(11) and z(10) and z(9) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1))  or  (z(12) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4)
					and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2)
					and z(1))  or  (z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
					not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(5)
					and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and  not z(1))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (
					not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(2) and z(1))  or  (z(12) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(8) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(8) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(10) and z(8) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(6) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(8) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(8) and z(7) and z(5) and z(3) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(5)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(6)
					and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5)
					and z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2)
					and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and z(4) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(9) and  not z(8) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1))  or  (z(12) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(4) and  not z(2) and z(1)
					and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(3) and  not z(1))  or  ( not z(12) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(1))  or  ( not z(12) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(1))  or  ( not z(11) and  not z(10) and z(9)
					and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and z(5) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(1))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(1))  or  ( not z(12) and z(11) and z(9) and  not z(7) and  not z(6)
					and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3)
					and z(1))  or  (z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(11)
					and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1) and z(0))  or  (z(12) and z(11) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1))  or  ( not z(12) and z(11) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(1))  or  (z(11) and z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(2) and z(1))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  ( not z(12) and z(11) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2)
					and  not z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1))  or  (z(11) and  not z(9) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4)
					and z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(2) and z(1))  or  (z(11) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and  not z(9)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(9) and  not z(7) and z(6) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (z(11)
					and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(2) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10)
					and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11)
					and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7)
					and z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9) and z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2)
					and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(9)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(2) and  not z(1))  or  (z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1))  or  (
					not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  (z(11) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(9) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1))  or  ( not z(11) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2)
					and z(1))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1))  or  (z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(1))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(1))  or  ( not z(11) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(11)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(2) and z(1))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2)
					and z(1))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1))  or  ( not z(11) and  not z(9)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1))  or  ( not z(11) and z(9) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(1))  or  (z(12) and  not z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(9) and  not z(8)
					and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1))  or  (
					z(12) and z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(9)
					and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(9)
					and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and z(1))  or  (z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(1))  or  (z(11) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and z(7) and  not z(6) and z(5) and z(3)
					and  not z(2) and z(1))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  (
					not z(11) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and z(1))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2)
					and z(1))  or  ( not z(11) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  (z(12) and  not z(11)
					and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1))  or  (z(11) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1))  or  (
					z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(0))  or  (z(12) and  not z(10)
					and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  ( not z(11) and  not z(9) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8)
					and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0));
					
					db(10) <= (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(2)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(2) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  (z(12) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and  not z(5) and z(4) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11)
					and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2))  or  (z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8)
					and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(7) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(11)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9)
					and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and z(7) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8)
					and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1)
					and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5)
					and z(4) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1)
					and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8)
					and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
					and z(3) and z(2) and z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and z(9) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and z(5)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(3) and z(2))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10)
					and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(6) and z(5) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2)
					and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(11)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(5)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2)
					and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (z(12)
					and z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(8) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2))  or  ( not z(11)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7)
					and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2))  or  ( not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2))  or  ( not z(12) and z(11) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(5) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and z(5) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(8) and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
					and  not z(2) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (
					z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(2) and z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1)
					and  not z(0))  or  (z(12) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1)
					and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1)
					and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and z(3) and z(2))  or  (z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(5) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10)
					and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and z(9)
					and z(8) and  not z(7) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(8) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(11)
					and  not z(10) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and  not z(5)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  (z(11) and  not z(10) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(8)
					and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(11)
					and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and z(9)
					and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2)
					and z(1))  or  (z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2))  or  ( not z(12) and z(11) and  not z(10)
					and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(5)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and z(8) and z(7) and z(5) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1))  or  (z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and z(2))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11)
					and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1))  or  ( not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10)
					and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(3) and z(2))  or  (z(11) and  not z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1))  or  (z(11) and z(10)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and z(10) and z(8) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(3)
					and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1)
					and z(0))  or  (z(11) and z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2))  or  ( not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11)
					and  not z(10) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(3)
					and z(2) and z(1))  or  ( not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11)
					and  not z(10) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and  not z(8) and z(6)
					and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5)
					and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and z(3) and z(2)
					and z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and z(1))  or  (
					z(11) and z(10) and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1))  or  (z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and  not z(8) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (
					not z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and z(8) and  not z(6)
					and z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(2) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(11)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0));
					
					db(9) <= (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(5) and z(4)
					and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4)
					and z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (
					z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(1))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(7) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(1) and z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(1))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(7) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (z(12)
					and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  ( not z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1))  or  ( not z(12) and z(10) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5)
					and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5)
					and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(6) and z(5) and z(4) and z(3)
					and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(2)
					and  not z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3)
					and z(1) and  not z(0))  or  (z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1)
					and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(11) and z(10)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(1))  or  (z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (
					not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(8) and z(7) and z(6) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(0))  or  (z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(8)
					and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7)
					and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6)
					and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6)
					and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(3)
					and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and z(0))  or  (z(12) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(9) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(0))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(3)
					and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3)
					and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(7) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and z(4) and z(3) and  not z(1))  or  (z(12) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4)
					and  not z(3) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(12) and z(10)
					and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(5) and z(4) and z(3) and  not z(1))  or  ( not z(12) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5)
					and  not z(4) and z(3) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(5) and z(4) and z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(1)
					and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(1))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and z(1))  or  (z(12) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and z(3)
					and z(1) and z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(5)
					and  not z(4) and z(3) and  not z(1))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(2)
					and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1)
					and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2)
					and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(10)
					and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3)
					and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5)
					and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and z(5) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3)
					and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(6) and z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(6) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(6) and z(5) and z(3) and z(2)
					and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(3) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(3) and z(2)
					and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(9)
					and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  (z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2) and z(1) and z(0))  or  (
					z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(6) and z(5)
					and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and z(5) and z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and z(10)
					and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0));
					
					db(8) <= ( not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10)
					and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(7) and z(6) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(7) and z(6) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(8) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and z(8) and z(7) and z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(6)
					and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(2)
					and z(1))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(8) and z(7) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2)
					and  not z(1))  or  ( not z(12) and  not z(11) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(4) and z(3)
					and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5)
					and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(3)
					and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1))  or  ( not z(12) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(8) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1)
					and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2)
					and z(1))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and z(7) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5)
					and z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and z(2) and z(1)
					and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6)
					and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6)
					and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4)
					and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(5) and z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3)
					and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(7) and  not z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(7) and z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7)
					and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7)
					and z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and z(2) and  not z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(12)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7)
					and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2)
					and  not z(1))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(12) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5)
					and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and z(10)
					and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2)
					and z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2)
					and z(1))  or  ( not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2)
					and z(1))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and z(9)
					and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  (z(11) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(11) and  not z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1)
					and z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1))  or  (z(11) and z(10) and z(9)
					and z(8) and z(7) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(9) and z(8) and z(7) and z(6)
					and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1))  or  (z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4)
					and z(3) and z(2) and z(1))  or  (z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(10) and z(9) and z(8) and  not z(7) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6)
					and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and z(5)
					and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(7) and  not z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7)
					and z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6)
					and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(2) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2)
					and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6)
					and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(10) and z(9)
					and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and z(7)
					and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and z(10)
					and z(9) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2)
					and z(1) and  not z(0))  or  (z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10)
					and z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(10) and z(9) and  not z(8) and z(7) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(10)
					and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1))  or  (z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(2) and z(1))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(11)
					and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(2) and z(1))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(2) and  not z(1))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(11) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(10) and z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and z(2) and z(1))  or  ( not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1))  or  (z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and z(9) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2)
					and  not z(1))  or  (z(10) and z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  (z(10) and z(9) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2)
					and z(1))  or  ( not z(10) and z(9) and  not z(8) and  not z(7) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(9) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(8) and z(7) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(4)
					and z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2)
					and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1)
					and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0));
					
					db(7) <= ( not z(12) and  not z(10) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and z(7) and  not z(5) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5)
					and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(9) and z(8) and z(7) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(5) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3)
					and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(2) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(3) and z(1) and  not z(0))  or  (z(12) and z(10) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6)
					and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(10) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and  not z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(6)
					and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7)
					and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(10) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5)
					and z(4) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and z(5) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10)
					and z(8) and z(7) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(3) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(10) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(5)
					and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(5) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(10) and z(8) and z(7) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6)
					and z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(9)
					and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(9) and z(8) and z(7) and z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and  not z(6) and  not z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6) and z(5)
					and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(5) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(8) and z(7) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(8) and z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  (z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(8) and  not z(7) and z(5)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and z(5)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(11) and  not z(9) and z(8) and z(7) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7)
					and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(3) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(4) and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(11) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8)
					and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8)
					and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and z(8) and  not z(7)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6)
					and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(5) and z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(1) and z(0))  or  (z(11) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(4) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4)
					and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3)
					and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(3) and z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5)
					and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(10) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(10) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(10)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(10) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(9) and  not z(8)
					and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(8) and z(7)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and z(9) and z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4)
					and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(0))  or  ( not z(11) and z(9) and  not z(8)
					and z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(4) and  not z(2) and  not z(0))  or  (
					z(12) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(11)
					and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6)
					and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and  not z(7) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and z(4) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1)
					and  not z(0))  or  (z(11) and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and z(8) and z(7) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(2) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6)
					and  not z(5) and  not z(4) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(4)
					and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(4) and z(3) and z(2)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(0))  or  (
					not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(0))  or  (z(11) and z(10) and  not z(8)
					and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6)
					and  not z(5) and z(4) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(5) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(4) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and z(7) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(3) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5)
					and z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2)
					and  not z(1))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(11)
					and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(5) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(0))  or  (
					not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(5)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(0))  or  ( not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (z(11) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(8) and z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4)
					and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and z(4) and z(3) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(6) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and z(5) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and z(3)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and  not z(4) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(4)
					and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3)
					and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(6) and  not z(5) and z(4) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5)
					and z(4) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(1) and  not z(0))  or  (
					z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4)
					and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8)
					and  not z(6) and  not z(4) and  not z(2) and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and z(6) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(6) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5)
					and z(4) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and z(7) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and z(8)
					and z(7) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4)
					and z(3) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(6) and z(4) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(4) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(4) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(0))  or  (z(11) and  not z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(8) and z(6) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6)
					and z(5) and z(4) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and  not z(4) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7)
					and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(6) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(11) and z(10) and z(8) and z(7) and z(5)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(4)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(3) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(9) and  not z(8) and z(7) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(8) and z(6) and z(4) and z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(10) and  not z(8) and z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(5)
					and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and  not z(0));
					
					db(6) <= (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  ( not z(10) and z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(10)
					and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
					not z(12) and  not z(11) and z(9) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(7)
					and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(4) and z(3) and z(1) and z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12) and z(11)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9)
					and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  ( not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(9) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and z(7) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6)
					and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and  not z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and  not z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(12) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(8) and z(7) and  not z(6) and z(5) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(2) and  not z(1) and  not z(0))  or  (z(10) and z(9) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(8)
					and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6) and z(4) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(10) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2)
					and z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(3) and z(2) and z(1) and z(0))  or  (z(10)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(8)
					and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(4)
					and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(9) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(8) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(7) and z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(10) and z(9) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and z(7) and z(6) and z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(5) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  (z(12) and z(10) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8)
					and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3)
					and z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8)
					and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3)
					and z(2) and z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(2)
					and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(12) and z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6)
					and z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(10) and z(8) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(5) and  not z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(0))  or  (z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1))  or  ( not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(8) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(8) and z(7) and  not z(6) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  ( not z(12) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(12) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(10) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12)
					and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(8) and z(7) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8)
					and z(7) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and z(7) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and z(7) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(7)
					and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(1))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and  not z(10) and  not z(9)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(9) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11)
					and  not z(10) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(9) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(5) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and z(9) and z(8) and z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(10) and  not z(9) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2)
					and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(2) and z(1) and  not z(0))  or  (z(10)
					and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2)
					and z(0))  or  (z(12) and z(11) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7)
					and z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7)
					and z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and z(7) and z(6) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8)
					and z(7) and z(6) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(5) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(10) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7)
					and z(6) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9)
					and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(10) and z(8) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and  not z(7) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and z(10) and  not z(8) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(10) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(10) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(10) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and  not z(6)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10) and z(8) and  not z(7)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(10) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(10) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(8) and z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(8) and z(7) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and z(10) and z(8) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(10) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(0))  or  (z(12) and z(11) and z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(6) and z(5) and z(4) and z(3) and z(2)
					and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12)
					and z(11) and z(8) and z(7) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(5) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(8) and z(7) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(10) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8)
					and  not z(7) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(10) and z(8) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(10) and z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(8) and  not z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and z(8) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10) and z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(10) and z(8) and z(7) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(0))  or  (z(10) and z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(10) and z(8) and z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and z(7) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(8) and z(7) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(10) and z(8) and z(7) and  not z(6) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and z(7) and z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(10) and z(9) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  ( not z(12) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(8) and z(7) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(4) and z(3)
					and  not z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1));
					
					db(5) <= (z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and z(8)
					and z(7) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(6) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(0))  or  (z(12) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2)
					and z(1))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(6)
					and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(2))  or  ( not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1))  or  ( not z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12)
					and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and  not z(8) and z(6)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(5) and z(4) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(5) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(2) and  not z(0))  or  (z(12) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8)
					and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  (
					z(12) and z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(1))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1))  or  ( not z(12) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and z(6) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9)
					and z(8) and z(7) and z(5) and z(4) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(5)
					and z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(4) and  not z(3) and z(2))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(6) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(0))  or  (z(11) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(1))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and z(8) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4)
					and z(2) and z(0))  or  (z(12) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(8) and z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2)
					and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8)
					and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (
					z(11) and z(9) and z(8) and  not z(7) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9)
					and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9)
					and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(9) and z(8) and z(7) and z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  (z(12) and  not z(10)
					and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and z(5) and z(4) and  not z(3) and  not z(2))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3)
					and z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(6) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2))  or  (z(12) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8)
					and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and z(8) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9)
					and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11) and z(9) and  not z(8) and z(7)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1))  or  (z(11) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(12) and z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1)
					and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6)
					and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and z(7) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3))  or  (
					z(12) and z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and  not z(7) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(4) and z(3) and z(2))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(5) and z(4) and z(3) and  not z(1))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and z(2))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and z(7) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(4) and  not z(3) and z(2)
					and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(3) and  not z(1))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(6)
					and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(4) and  not z(3) and z(2)
					and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2))  or  ( not z(11) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(6)
					and z(4) and z(3) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11)
					and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and z(8)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(5) and  not z(4)
					and z(3) and  not z(1))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and z(1))  or  (z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(9)
					and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8)
					and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(4)
					and  not z(3))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(9) and z(8)
					and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(4) and  not z(3) and z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and z(7) and z(6)
					and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(7) and z(6) and z(5) and z(4)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(9) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(9)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  (z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2))  or  (z(12)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(5) and z(4) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and  not z(1))  or  (
					not z(12) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and  not z(1))  or  ( not z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2)
					and  not z(1))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(6) and  not z(5) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and z(8) and z(6) and z(5) and  not z(3) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(5) and  not z(4) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(4) and z(3) and z(2))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3)
					and z(2))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9)
					and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(8) and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7)
					and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7)
					and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1))  or  ( not z(12) and  not z(9) and z(8) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(4)
					and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(4)
					and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12)
					and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and z(8)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(4)
					and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and z(11) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (z(12) and z(11) and  not z(9) and z(8)
					and z(7) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  ( not z(12) and z(9) and z(8) and z(6) and z(4) and  not z(3) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and z(6)
					and z(5) and z(4) and z(3) and z(1))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and z(3) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and z(11)
					and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12) and z(11) and z(9) and z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(6) and  not z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(1))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3)
					and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and z(8) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(11) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(11)
					and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and z(9) and z(8) and  not z(7) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(9) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6)
					and  not z(4) and z(3) and z(2))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and z(3))  or  (z(11) and  not z(9) and z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(9) and z(8) and z(7) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(1) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(4) and z(3) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(4) and  not z(3) and z(2))  or  (
					not z(11) and z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and z(5) and  not z(4)
					and z(3) and  not z(1))  or  ( not z(11) and  not z(9) and  not z(8) and z(7) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6)
					and  not z(5) and z(4) and  not z(3))  or  ( not z(11) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and z(2))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3))  or  ( not z(12) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(4) and  not z(3))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(4) and  not z(3) and z(1))  or  ( not z(12) and z(9) and z(8) and  not z(6)
					and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(1))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and  not z(1))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(7) and z(4) and  not z(3) and z(1))  or  ( not z(12) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(1))  or  ( not z(12) and z(11)
					and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(12) and  not z(11) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3)
					and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and z(1))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(6)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(1))  or  (z(12) and z(11)
					and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(9)
					and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7)
					and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(4)
					and  not z(3) and z(1))  or  (z(12) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(1))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8)
					and z(6) and z(4) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(4) and  not z(3))  or  ( not z(12) and z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(5) and  not z(4) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2)
					and z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and z(7) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(6) and z(4) and  not z(3));
					
					db(4) <= ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(9) and z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(5)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9)
					and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  (z(11) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(2) and z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2)
					and z(1))  or  (z(12) and  not z(11) and z(10) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11)
					and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(7)
					and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7) and z(6) and z(5)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6)
					and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3)
					and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3)
					and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4)
					and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9)
					and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(4) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(7) and z(6) and z(5) and z(4)
					and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5)
					and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(3)
					and z(2) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and z(11) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(7)
					and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and z(4) and z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(4) and z(3)
					and z(2) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (z(11) and z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8)
					and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4)
					and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(6)
					and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(0))  or  (z(12) and z(11) and  not z(9) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4)
					and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7)
					and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(6) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(1))  or  ( not z(12) and z(11) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(3)
					and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2)
					and z(0))  or  (z(12) and z(11) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(7) and z(6) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5)
					and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1))  or  (z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(6)
					and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5)
					and  not z(4) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4) and  not z(2)
					and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(6)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10)
					and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(6) and z(5) and z(4) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and z(10) and z(9) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(6) and z(5) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(6)
					and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and z(6) and  not z(5) and z(4) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(6) and  not z(5)
					and  not z(4) and  not z(2) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(6) and  not z(5) and z(4) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(6)
					and  not z(5) and z(4) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4)
					and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(6)
					and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(4)
					and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(6) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4)
					and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1));
					
					db(3) <= (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(11) and z(10)
					and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(8) and z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7)
					and z(6) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(5) and z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(3)
					and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(1))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(8) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and z(10)
					and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(11) and z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(11) and  not z(10) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(9)
					and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(3)
					and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2)
					and z(1))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2)
					and z(1))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2))  or  (
					not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(3) and  not z(2) and z(1))  or  (z(12) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
					and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and z(1))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and z(2))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  (z(11)
					and  not z(10) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2))  or  (z(12) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9)
					and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(3) and z(2) and z(1))  or  (
					z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(5) and  not z(4) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2)
					and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(5)
					and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(12)
					and z(11) and z(10) and z(8) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(8) and z(7) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8)
					and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3)
					and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(11)
					and z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7)
					and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2)
					and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(8) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and z(5) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(5) and z(4) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(3) and  not z(2)
					and z(1))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and z(2) and  not z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4)
					and z(3) and z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (z(11)
					and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(5) and  not z(4) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(5) and z(4) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(0))  or  (z(12) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(5)
					and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8)
					and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(6)
					and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5)
					and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(8) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(6) and  not z(5)
					and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(8) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(6)
					and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6)
					and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(6) and  not z(5) and  not z(4)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(6) and z(5) and z(4) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(6) and z(5)
					and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6)
					and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7) and  not z(6) and  not z(5)
					and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(6) and z(5) and z(4) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(7) and z(6) and  not z(5)
					and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(7) and z(6)
					and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(5) and  not z(4) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(5) and  not z(4)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(6)
					and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(6) and z(5) and z(4)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(7) and z(6) and  not z(5) and z(4) and z(3)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(6)
					and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(5)
					and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(0));
					
					db(2) <= ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and z(6)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6)
					and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3)
					and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7)
					and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9)
					and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(6)
					and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(8) and z(7) and  not z(6) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(4) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(11)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6)
					and z(5) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4)
					and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  ( not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6)
					and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3)
					and z(2) and z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(3) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7)
					and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7)
					and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7)
					and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4)
					and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9)
					and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(10) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(10)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and  not z(6) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(10) and z(8) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(8) and z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2)
					and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and z(10)
					and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7)
					and z(6) and  not z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(4) and  not z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(4) and z(3) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(4)
					and  not z(3) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7)
					and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(7) and z(6)
					and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(4)
					and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(6) and z(5) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11)
					and z(10) and z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(7) and z(6) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(4) and z(3) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and z(4) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and  not z(3) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(4) and z(3)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and  not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and z(8) and z(6) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(6) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(6) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(10) and z(9) and z(8)
					and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(5)
					and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(8) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(8) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(9)
					and z(8) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and  not z(10)
					and z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and  not z(8) and  not z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8)
					and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(8) and z(7) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(8) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(8) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(8) and  not z(7) and z(5)
					and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and z(7) and z(5) and z(4) and z(3)
					and z(2) and z(1))  or  (z(12) and  not z(10) and  not z(8) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(8) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and  not z(8) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(8)
					and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8)
					and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(8) and z(7) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6)
					and z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4)
					and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3)
					and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and z(10) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(7) and z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(4)
					and z(3) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0));
					
					db(1) <= (z(12) and  not z(11) and z(10) and  not z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(10) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(10) and z(8) and  not z(6)
					and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11)
					and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(9)
					and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8)
					and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(9) and z(8) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  (z(12) and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(7) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  (z(11) and z(9) and  not z(8) and z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(6) and  not z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(9)
					and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(6) and z(5) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(2) and z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(7)
					and  not z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and z(4)
					and z(3) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(10) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1))  or  ( not z(11) and z(10) and z(8) and  not z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(10)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(8) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(10) and z(7) and  not z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(11)
					and z(10) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10)
					and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(9)
					and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(12)
					and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(12) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1))  or  (z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(9)
					and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(9) and z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4)
					and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4)
					and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(12) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(9)
					and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(6) and z(5)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(9) and z(8) and  not z(6) and z(5) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10)
					and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(8)
					and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and z(6)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3)
					and z(1))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1))  or  (
					z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
					z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7)
					and z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
					and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  (z(11) and z(10) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and z(10) and z(8)
					and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7)
					and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8)
					and  not z(7) and  not z(6) and z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(7) and z(5) and z(4)
					and z(3) and z(2) and z(0))  or  (z(12) and z(10) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8)
					and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2)
					and z(1))  or  ( not z(12) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(11) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(10) and z(9) and  not z(8)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (z(11) and z(9) and  not z(8) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and z(7) and z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(9) and  not z(8) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(11) and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and z(1))  or  (z(12) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(2) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(1))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2)
					and z(1))  or  (z(12) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(9)
					and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6)
					and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5)
					and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(4) and  not z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4)
					and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4)
					and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4)
					and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4)
					and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(4) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  (z(12) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(7) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7)
					and z(6) and z(5) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6)
					and z(5) and z(4) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(1))  or  ( not z(11) and z(10) and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  ( not z(11) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(1)
					and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(11) and z(10) and z(8)
					and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6)
					and z(5) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					z(11) and z(10) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(11) and z(10)
					and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  ( not z(12) and z(11) and z(10)
					and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(3)
					and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(11)
					and z(10) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10)
					and z(8) and z(7) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(7)
					and z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and z(6) and z(5) and z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(3)
					and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10)
					and z(8) and  not z(7) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7)
					and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12)
					and z(11) and z(10) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and z(10)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(8)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(8) and z(7)
					and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(7) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(10)
					and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8)
					and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7)
					and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(4)
					and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7)
					and z(6) and z(5) and z(4) and z(3) and z(1))  or  ( not z(12) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and z(6) and  not z(5) and  not z(3)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(7) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(10) and z(8)
					and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(7) and z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(10) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(7) and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(12) and z(10) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and z(11) and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7)
					and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7) and  not z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(12) and  not z(10)
					and z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7)
					and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(3)
					and  not z(1))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11)
					and  not z(10) and z(9) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  (z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(3) and z(2)
					and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (
					z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9)
					and z(7) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7)
					and z(6) and  not z(5) and z(3) and z(1))  or  (z(12) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(9)
					and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(5)
					and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6)
					and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3)
					and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(7) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(4)
					and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7)
					and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(5) and z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(8) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(12)
					and z(10) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and  not z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and z(10) and z(8) and z(6) and  not z(5) and z(4) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  (
					not z(12) and z(10) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(10)
					and z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8)
					and z(7) and  not z(6) and  not z(5) and z(2) and  not z(0))  or  ( not z(12) and z(10) and  not z(8) and z(6) and  not z(5) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(11) and z(10) and z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (
					z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1))  or  ( not z(11) and z(10)
					and  not z(8) and z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(6) and z(5) and z(3) and z(2)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(8) and  not z(7) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7)
					and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(4)
					and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and z(4) and z(3) and z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and z(10)
					and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(8) and  not z(6)
					and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and z(7) and z(6) and  not z(5)
					and  not z(3) and z(2) and z(0))  or  (z(12) and z(10) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
					not z(11) and z(10) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(10)
					and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and  not z(7) and  not z(6)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(7) and  not z(6) and z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(7) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(12) and z(11) and z(10) and  not z(7)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(7) and  not z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(7) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(3) and z(1) and  not z(0))  or  (z(11) and z(10) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and z(10) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(10) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(6) and z(5)
					and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(3)
					and z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(7)
					and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(10)
					and z(9) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(7)
					and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(7) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(0))  or  ( not z(12) and z(10) and z(7) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(12)
					and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(10)
					and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(7)
					and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(12) and z(10) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7)
					and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(7)
					and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(3) and z(1) and z(0))  or  ( not z(12) and z(10) and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(7)
					and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(10) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7)
					and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1))  or  (z(12) and  not z(11) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and  not z(6) and z(5) and z(3) and z(1))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(6)
					and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2)
					and z(1) and z(0));
					
					db(0) <= (z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9)
					and z(8) and z(7) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7)
					and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3)
					and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11)
					and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1)
					and z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
					z(12) and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(12) and z(10) and z(9) and z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9)
					and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(10) and z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7) and z(5) and z(4)
					and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4)
					and z(3) and z(2) and z(1))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(4)
					and z(3) and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
					and z(2) and z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3)
					and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(3) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1))  or  (
					z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and z(10)
					and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8)
					and z(7) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and z(4)
					and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1))  or  (
					z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and z(2) and  not z(1))  or  (z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  (
					z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					not z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (
					z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
					not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(11)
					and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10)
					and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(10)
					and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10)
					and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (
					not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(6) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4)
					and z(2) and z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(1))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(1) and  not z(0))  or  (z(11) and  not z(10)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and z(9)
					and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8)
					and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8)
					and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and  not z(4)
					and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(4)
					and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4)
					and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7)
					and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
					and z(3) and z(2) and  not z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(4)
					and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(4) and z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(5) and z(4) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3)
					and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
					and  not z(3) and z(0))  or  ( not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
					z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and z(10) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(11) and z(10) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7)
					and  not z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6)
					and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(3) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(3) and z(2) and z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(4) and z(3)
					and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and z(7) and z(5) and z(3) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and z(7) and z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7)
					and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(6)
					and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3)
					and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2)
					and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and z(11) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and z(10)
					and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and z(5)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(5)
					and z(4) and z(3) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(5) and  not z(3) and z(2)
					and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and z(5) and z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1))  or  (z(12)
					and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and  not z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12)
					and z(11) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12)
					and z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(12) and z(11)
					and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(10) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7)
					and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and z(6)
					and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and  not z(7) and z(6)
					and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(4) and z(3)
					and  not z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
					not z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10)
					and z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(11) and z(10)
					and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(10) and z(9)
					and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8)
					and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(6) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(7)
					and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5)
					and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(4)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(4)
					and z(3) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
					and z(1))  or  (z(11) and z(10) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
					z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(12) and z(11) and  not z(8) and z(7)
					and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(10) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and  not z(9) and z(8) and z(7)
					and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(10) and z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and z(6)
					and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and z(6) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and z(8) and  not z(7) and  not z(6) and z(5)
					and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and z(5)
					and z(4) and z(3) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and  not z(3)
					and  not z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3)
					and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(3)
					and z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3)
					and z(2) and z(1))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
					and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
					and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3)
					and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1))  or  (z(12)
					and z(11) and z(10) and z(9) and z(8) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and  not z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(11) and z(10) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and z(6)
					and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5)
					and z(4) and z(3) and z(1))  or  ( not z(12) and z(11) and z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(4)
					and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and z(1) and z(0))  or  (z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1))  or  (z(12) and  not z(11) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
					and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(1))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1)
					and z(0))  or  ( not z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (
					z(12) and z(11) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12)
					and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7)
					and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
					and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(3) and z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1))  or  ( not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (
					not z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					not z(12) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (z(12)
					and  not z(11) and z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(8)
					and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(10) and  not z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1))  or  (z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (z(12) and z(11) and  not z(9) and z(8)
					and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and z(8) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and z(7) and z(6)
					and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11) and z(10) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(9) and z(8) and z(7) and z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4)
					and z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and  not z(6) and z(5) and  not z(3)
					and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2)
					and  not z(1))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(1))  or  (
					not z(12) and z(11) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11)
					and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(11) and z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(8)
					and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8)
					and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7)
					and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and  not z(6) and z(5)
					and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and z(6) and z(5)
					and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
					and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(0))  or  (z(11) and  not z(10) and z(9) and z(8) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and  not z(5)
					and z(3) and  not z(1))  or  ( not z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
					not z(12) and z(11) and z(10) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(12)
					and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6)
					and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(5)
					and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and z(6) and z(5)
					and z(3) and z(2) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
					and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(6) and z(5) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(0))  or  (z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(11)
					and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(10)
					and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(12)
					and z(11) and z(10) and  not z(9) and z(8) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11)
					and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9)
					and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8)
					and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8)
					and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(8) and z(7)
					and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(5)
					and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11) and z(10) and z(8) and z(7) and  not z(5) and  not z(4)
					and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3)
					and z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3)
					and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2)
					and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1)
					and z(0))  or  (z(12) and z(11) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
					and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
					z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(11)
					and  not z(10) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(11) and  not z(10)
					and z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and z(8)
					and z(7) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(6)
					and z(5) and z(3) and z(2) and z(0))  or  ( not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
					and z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
					and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
					z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and  not z(10) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
					not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(12)
					and z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and z(8) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and z(9)
					and z(8) and z(7) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(11) and  not z(10) and  not z(9) and z(8)
					and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and z(7) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(8) and  not z(7)
					and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(6)
					and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(8) and  not z(7)
					and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(5) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3)
					and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3)
					and  not z(2) and  not z(0))  or  (z(10) and  not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2)
					and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
					and z(0))  or  (z(12) and z(11) and z(10) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
					not z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(9)
					and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10)
					and  not z(9) and z(8) and z(7) and  not z(5) and  not z(3) and z(0))  or  (z(12) and  not z(11) and z(9) and  not z(8) and  not z(7)
					and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(8) and  not z(7) and z(5)
					and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11) and  not z(9) and  not z(8) and z(7) and z(5)
					and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(5) and  not z(4)
					and z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3)
					and z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (
					z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(8) and  not z(7) and z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and z(10) and z(9) and  not z(8) and  not z(7)
					and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5)
					and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and z(3) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(5) and  not z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and  not z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (z(11) and  not z(10)
					and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8)
					and  not z(7) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8)
					and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8)
					and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and z(7)
					and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7)
					and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2)
					and z(0))  or  (z(12) and  not z(11) and z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and z(11) and z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(3) and z(1) and z(0))  or  (z(12) and z(11) and  not z(10)
					and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8)
					and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(7) and z(6)
					and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and  not z(4)
					and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2)
					and  not z(1) and  not z(0))  or  ( not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1)
					and z(0))  or  ( not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (
					z(11) and z(10) and  not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(11)
					and z(10) and  not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(11) and  not z(10)
					and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  (z(12) and z(11) and z(10)
					and  not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12) and z(10) and  not z(9) and z(8)
					and z(7) and  not z(6) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(11) and z(10) and z(9) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and z(7) and  not z(6) and  not z(4) and z(3)
					and  not z(1) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and z(6) and z(4) and z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(10) and z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(11) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1))  or  ( not z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1))  or  (z(11) and  not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(7) and z(6) and z(4)
					and z(3) and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and z(7) and z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (z(12) and z(10) and z(9)
					and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(10) and z(9) and z(8)
					and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(11) and  not z(10) and  not z(9) and  not z(7) and z(6)
					and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(12) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6)
					and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(12) and z(10) and  not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
					and  not z(4) and z(3) and z(1))  or  (z(12) and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(4) and z(3)
					and z(1) and z(0))  or  (z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
					and  not z(1))  or  ( not z(12) and z(11) and z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1) and z(0))  or  (
					z(12) and  not z(10) and z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and z(7) and z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(11) and  not z(10)
					and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and  not z(10) and  not z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(10) and  not z(9) and z(8) and  not z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(12) and z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(1))  or  (z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
					and  not z(3) and z(1))  or  ( not z(12) and  not z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3)
					and z(1))  or  ( not z(11) and  not z(10) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
					not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11)
					and z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(10) and  not z(9)
					and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(12) and  not z(10) and z(9)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(11) and z(10) and  not z(9) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and  not z(9) and  not z(8) and  not z(7)
					and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(12) and z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
					and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
					and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
					not z(11) and  not z(10) and z(9) and z(8) and z(7) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(11) and z(10)
					and  not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(11) and z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(11) and z(10) and z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(7)
					and z(6) and z(5) and z(3) and  not z(1))  or  (z(12) and z(11) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(4)
					and  not z(3) and z(1) and z(0))  or  (z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and z(1))  or  ( not z(12) and  not z(11) and z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(12)
					and  not z(11) and  not z(10) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1))  or  ( not z(11) and  not z(10) and z(8)
					and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(11) and z(10) and  not z(8) and z(7)
					and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(11) and z(10) and  not z(8) and z(7) and z(6) and  not z(5) and z(4)
					and  not z(3) and  not z(2) and z(1))  or  (z(11) and  not z(10) and z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (
					z(12) and  not z(11) and  not z(10) and  not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(0))  or  ( not z(12)
					and  not z(11) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11)
					and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and z(9) and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(8) and z(7)
					and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(6)
					and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and  not z(8) and z(7) and  not z(6)
					and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(11) and z(10) and  not z(9) and z(7) and z(6) and z(5) and  not z(4)
					and z(3) and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(6) and  not z(5) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
					and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  (
					z(12) and  not z(11) and z(10) and z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  ( not z(12)
					and z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and z(10) and  not z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(11) and  not z(10) and z(8)
					and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and  not z(8) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8)
					and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(6)
					and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and z(6) and z(5) and  not z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (
					z(10) and z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10)
					and  not z(9) and z(8) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8)
					and z(7) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  ( not z(11) and  not z(10) and  not z(9) and z(8) and z(7) and  not z(5)
					and z(4) and z(2) and z(1) and z(0))  or  ( not z(11) and z(10) and  not z(9) and z(8) and  not z(5) and z(4) and  not z(3)
					and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(11) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(12)
					and z(11) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and  not z(10) and z(9) and z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(8)
					and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9)
					and z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and z(7)
					and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and  not z(6) and z(5)
					and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(3) and z(1))  or  (z(12) and z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					not z(11) and z(10) and z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(12)
					and z(11) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(12) and z(11)
					and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(11) and z(10) and z(8) and z(7)
					and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and  not z(5)
					and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and  not z(6)
					and  not z(5) and z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and z(7) and  not z(6)
					and z(5) and z(3) and z(1))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2)
					and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8) and z(5) and z(3) and z(2) and z(1)
					and  not z(0))  or  ( not z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
					z(10) and z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(11) and  not z(10)
					and  not z(9) and z(8) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9)
					and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11) and z(10) and  not z(9) and  not z(8)
					and z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  ( not z(12) and z(11) and z(8) and  not z(7) and z(5) and z(4)
					and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and  not z(10) and  not z(9) and z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(6) and z(5) and z(3)
					and  not z(2) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(5) and z(3) and z(2) and  not z(0))  or  (
					z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and  not z(10) and z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11)
					and z(10) and z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(0))  or  (z(12) and  not z(10) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(10) and z(9)
					and z(8) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8) and  not z(7)
					and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(5)
					and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(5) and  not z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(6) and z(5) and z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1)
					and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(11)
					and z(10) and  not z(9) and  not z(8) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(11)
					and  not z(10) and  not z(9) and z(8) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11)
					and  not z(8) and  not z(7) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and z(9) and z(8) and z(7)
					and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and  not z(11) and z(9) and z(8) and  not z(7) and z(5)
					and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
					and  not z(2) and  not z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
					and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(1)
					and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
					not z(12) and  not z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12)
					and z(11) and z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(8) and z(7) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10) and  not z(9)
					and  not z(8) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(10) and z(9) and  not z(8) and z(7) and z(5)
					and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and  not z(5)
					and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6)
					and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and  not z(8) and z(7) and  not z(5) and z(3) and z(2)
					and  not z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(9) and  not z(8) and  not z(5) and  not z(3) and z(2) and z(1)
					and  not z(0))  or  (z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and z(11) and z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11)
					and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9)
					and z(8) and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7)
					and  not z(6) and z(5) and  not z(3) and z(0))  or  ( not z(11) and  not z(10) and z(9) and  not z(8) and  not z(7) and z(5) and z(4)
					and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(3)
					and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(5) and z(3) and  not z(2) and  not z(1)
					and z(0))  or  ( not z(12) and  not z(11) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
					not z(12) and  not z(11) and  not z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(9) and  not z(8) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and z(10)
					and z(8) and z(7) and z(5) and z(3) and z(2) and  not z(0))  or  (z(11) and  not z(10) and  not z(8) and  not z(7) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(9) and  not z(8) and z(7)
					and z(6) and  not z(5) and  not z(3) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and z(5) and z(3) and z(1)
					and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
					not z(12) and z(11) and z(10) and z(9) and  not z(8) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12)
					and z(11) and z(9) and z(8) and  not z(7) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(12) and z(11) and  not z(9)
					and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9)
					and  not z(8) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(5) and z(4)
					and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and z(10) and z(8) and  not z(7) and  not z(5) and z(4)
					and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and z(8) and  not z(7) and z(5) and z(3) and z(2)
					and z(1) and  not z(0))  or  (z(11) and  not z(10) and z(9) and  not z(8) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(10)
					and z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and  not z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(12) and z(11) and  not z(10) and z(8)
					and  not z(7) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(12) and z(11) and  not z(8) and z(7) and z(5)
					and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and z(3)
					and z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(5) and z(3) and  not z(2)
					and z(1) and  not z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and z(8) and z(7) and  not z(5) and z(3) and z(2)
					and z(0))  or  ( not z(12) and  not z(11) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
					z(12) and  not z(11) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and z(10) and  not z(9) and  not z(8) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(9) and  not z(8) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10) and  not z(9) and  not z(8)
					and z(7) and z(5) and z(4) and z(3) and z(0))  or  (z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and z(5) and z(4)
					and  not z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(9) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  (z(12) and  not z(11) and z(8) and z(7) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
					z(12) and  not z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and z(7) and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(9)
					and  not z(8) and z(7) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(11) and z(10) and z(9) and  not z(8) and z(5)
					and z(4) and z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and z(9) and z(8) and z(5) and z(3)
					and  not z(2) and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
					and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  (
					not z(12) and  not z(11) and z(10) and  not z(8) and  not z(7) and  not z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and  not z(11) and  not z(10) and z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11)
					and z(10) and  not z(9) and z(8) and z(7) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(12) and z(11) and  not z(10)
					and  not z(8) and z(7) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9)
					and  not z(8) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and  not z(7)
					and z(5) and z(3) and z(1) and z(0))  or  ( not z(12) and z(11) and  not z(10) and  not z(8) and z(7) and z(5) and z(3)
					and  not z(2) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(8) and  not z(7) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and  not z(11)
					and z(10) and  not z(8) and z(7) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10)
					and  not z(9) and  not z(8) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(9) and  not z(8) and z(7)
					and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(12) and  not z(11) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2)
					and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(0))  or  (
					z(12) and  not z(11) and  not z(10) and z(9) and z(8) and  not z(7) and  not z(5) and z(3) and z(0))  or  ( not z(12) and  not z(11)
					and z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(1) and z(0))  or  (z(12) and z(11) and z(10) and  not z(8)
					and  not z(7) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(12) and z(11) and z(10) and z(9) and z(8) and z(6)
					and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(12) and z(10) and z(9) and z(8) and z(7) and z(6) and  not z(5)
					and z(4) and  not z(3) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
					and  not z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and z(8) and z(5) and  not z(4) and  not z(3)
					and z(2) and  not z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3)
					and z(2) and  not z(0))  or  (z(12) and  not z(11) and z(10) and z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2)
					and  not z(0))  or  (z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
					and  not z(1))  or  (z(12) and  not z(11) and  not z(10) and  not z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
					and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2)
					and  not z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
					not z(11) and  not z(10) and z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(12)
					and  not z(11) and z(10) and  not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12)
					and z(11) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(11) and z(10)
					and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(12) and z(11) and z(10)
					and  not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(12) and  not z(11) and  not z(10)
					and z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(12) and z(11)
					and z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(12) and  not z(11)
					and  not z(10) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(11)
					and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(12) and  not z(10)
					and  not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(11) and  not z(10)
					and z(9) and z(8) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(12) and z(11) and  not z(10) and z(9) and z(8)
					and  not z(7) and z(6) and z(5) and z(3) and z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and z(6)
					and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7) and z(6)
					and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and  not z(8) and  not z(7)
					and  not z(6) and z(5) and z(4) and z(3) and  not z(0))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8) and  not z(7)
					and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and z(8)
					and z(5) and z(3) and z(2) and  not z(0))  or  ( not z(12) and z(11) and  not z(10) and z(8) and z(7) and  not z(5) and z(3)
					and  not z(2) and  not z(1) and z(0))  or  ( not z(12) and  not z(11) and z(10) and  not z(9) and  not z(8) and  not z(6) and  not z(5)
					and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(12) and  not z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5)
					and  not z(4) and z(3) and z(0))  or  ( not z(12) and z(11) and z(10) and z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
					and z(4) and z(3) and z(2) and z(0))  or  (z(12) and  not z(11) and  not z(8) and z(7) and z(5) and z(3) and z(2) and  not z(1)
					and z(0))  or  (z(12) and  not z(11) and  not z(10) and z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and z(0))  or  (
					z(12) and z(11) and  not z(10) and  not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and z(0))  or  ( not z(11) and z(10)
					and  not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11)
					and  not z(10) and  not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(1))  or  ( not z(12) and z(11) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(11) and z(10) and  not z(8)
					and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(12) and  not z(11) and  not z(8)
					and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(10) and  not z(9) and  not z(8) and z(7) and z(6)
					and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(12) and z(11) and z(10) and  not z(9) and  not z(8) and z(7)
					and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(12) and z(11) and z(10) and  not z(9) and  not z(7)
					and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0));
				else
					en_out <= '0';
			end if;
		end if;
	end process;
end rtl;
