----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:14:26 04/17/2009 
-- Design Name: 
-- Module Name:    master_rom - rtl 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity master_rom is
	port (
		clk, reset,en_in	:	in std_logic;
		z						:	in std_logic_vector (9 downto 0); -- address bus
		counter				:	in std_logic_vector (4 downto 0);
		db						:	out std_logic_vector (4 downto 0) -- data bus
	);
end master_rom;

architecture rtl of master_rom is
	signal cnt		:	std_logic_vector(4 downto 0);
	signal ctrl		:	std_logic_vector (2 downto 0);
begin
	sel_rom: process (clk,ctrl)
	begin
		if (clk'event and clk = '1') then
			if (reset = '1') then
				db <= (others => '0');
			elsif (en_in = '1') then
				case (ctrl) is
				
					when "000" =>
db(4) <= ( not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(5)
     and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(8) and z(7) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7)
     and z(6) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(8)
     and z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(5) and  not z(4) and z(2)
     and  not z(1) and  not z(0))  or  (z(8) and z(7) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  (
     not z(8) and z(7) and z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(4)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
     not z(8) and  not z(7) and z(6) and z(5) and z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and z(5) and z(2)
     and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(8)
     and z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(5) and  not z(4) and  not z(2)
     and z(1) and  not z(0))  or  (z(8) and z(7) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  (
     not z(8) and z(7) and z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(4)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (
     not z(8) and  not z(7) and z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and z(5) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7)
     and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
     not z(8) and z(7) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and z(2) and z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
     not z(8) and  not z(7) and z(6) and  not z(5) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and  not z(5) and z(2)
     and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(8)
     and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and z(2)
     and z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(5)
     and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(6) and  not z(5) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(6)
     and z(5) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9)
     and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1)
     and z(0))  or  (z(9) and z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(6) and z(5) and z(4)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(6) and z(5) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(5)
     and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9)
     and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(6) and z(5) and  not z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(9) and z(5) and  not z(4) and z(2)
     and z(1) and z(0))  or  (z(9) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and z(6)
     and  not z(5) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  (
    z(9) and z(6) and z(5) and z(2) and z(1) and z(0));

db(3) <= (z(9) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and z(7) and z(6) and z(4)
     and z(3) and  not z(2) and z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
    z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5)
     and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
     and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7)
     and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9)
     and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(3) and z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
    z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
    z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5)
     and  not z(4) and z(3) and z(2) and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5)
     and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(5) and z(4)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  (z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(7) and  not z(6) and  not z(5) and z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
     and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(8)
     and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
     and  not z(3) and  not z(2) and z(1))  or  (z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
    z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(4)
     and z(3) and z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3)
     and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(3) and  not z(2) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(3) and  not z(2) and  not z(1))  or  ( not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (z(9) and z(7) and  not z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
     and z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(8) and  not z(7) and  not z(6)
     and z(5) and z(3) and z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (
    z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(4) and  not z(3)
     and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(3) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (
    z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and  not z(3) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and  not z(2))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (
     not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and z(2))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2))  or  (
     not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
     and  not z(2))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and z(4) and z(2))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2))  or  ( not z(9) and  not z(8)
     and  not z(6) and z(5) and  not z(3) and z(2))  or  ( not z(9) and z(8) and  not z(6) and z(5) and z(3) and z(2))  or  (z(9)
     and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2))  or  (z(9) and z(8) and z(7) and z(6) and z(4) and  not z(2))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(2))  or  (z(9) and z(8) and z(7) and z(6) and  not z(4) and z(2))  or  (
    z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and  not z(2))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2))  or  ( not z(9) and z(7) and  not z(6)
     and z(5) and z(3) and  not z(2))  or  ( not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9)
     and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2))  or  (z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2)
     and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2)
     and z(0))  or  (z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(0));

db(2) <= (z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7)
     and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9)
     and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4)
     and z(3) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(4) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and z(4) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(0))  or  ( not z(9)
     and  not z(8) and z(7) and z(6) and z(4) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(4) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(4) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(4) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
     and  not z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2))  or  ( not z(9)
     and z(8) and z(7) and z(6) and z(5) and  not z(3))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2)
     and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  (z(9)
     and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(3) and  not z(2))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2))  or  ( not z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and z(3))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(9)
     and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(4) and z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and z(3) and z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (
    z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(4) and  not z(3) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(4)
     and  not z(3))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2))  or  ( not z(9) and z(8) and z(7)
     and z(5) and z(4) and  not z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(1))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and z(3) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3))  or  (z(9)
     and  not z(8) and z(7) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and z(4)
     and z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2))  or  (z(9) and z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(5) and  not z(3)
     and z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2))  or  (z(9) and z(8)
     and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(3)
     and z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(2))  or  (z(9) and  not z(8)
     and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1));

db(1) <= ( not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8)
     and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(9)
     and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(4)
     and  not z(3) and z(0))  or  ( not z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and  not z(6) and z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(7) and  not z(6) and z(5)
     and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9)
     and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(8)
     and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and z(0))  or  (z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8)
     and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(6) and  not z(5) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(7) and z(6) and z(5) and z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2))  or  (z(9)
     and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5)
     and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2))  or  (
     not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(9) and z(8) and z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2))  or  (z(9) and z(8) and z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2)
     and z(1) and  not z(0))  or  ( not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(7)
     and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9)
     and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5)
     and z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2))  or  (
     not z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9)
     and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2))  or  (z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(9) and z(7) and z(6)
     and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8)
     and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5) and z(4)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2))  or  (z(9) and  not z(8) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  (z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and z(4) and  not z(3) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(8) and z(6)
     and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(7)
     and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(6) and z(4) and z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(4)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(6) and z(4)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1)
     and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8)
     and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(5) and z(4) and  not z(3) and z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9)
     and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(7) and z(5) and  not z(4)
     and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and z(3) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2))  or  (
     not z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(4)
     and z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(0))  or  ( not z(9)
     and z(8) and z(7) and z(6) and z(5) and z(3) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3)
     and  not z(2))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and  not z(4) and z(3) and z(2))  or  ( not z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
     and  not z(3) and z(2))  or  ( not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(7) and  not z(6)
     and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and z(3) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(7)
     and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3)
     and z(1) and  not z(0))  or  (z(9) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and  not z(3)
     and  not z(1) and z(0))  or  (z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5)
     and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(6)
     and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0));

db(0) <= (z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6)
     and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(8) and z(7) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(6) and  not z(5)
     and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(7)
     and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(7)
     and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  (z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(7) and z(6)
     and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2)
     and z(1) and z(0))  or  (z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
     not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5)
     and z(2) and  not z(1) and z(0))  or  (z(9) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(1) and z(0))  or  ( not z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(1))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(5) and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(1))  or  (z(9)
     and z(8) and  not z(7) and z(6) and z(5) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(5) and z(1) and  not z(0))  or  (z(9) and  not z(6) and  not z(5) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(5)
     and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(1))  or  (z(9) and z(8) and  not z(7)
     and  not z(5) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and z(5) and z(4) and  not z(3))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3))  or  ( not z(9)
     and  not z(8) and z(7) and z(6) and  not z(5) and z(3))  or  (z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(2) and  not z(0))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7)
     and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(2) and z(0))  or  (z(9) and z(8)
     and z(7) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(2) and z(0))  or  (z(9)
     and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5)
     and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1)
     and z(0));

					when "001" =>

db(4) <= ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
     and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(1) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5)
     and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(0))  or  (
     not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (
     not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(9) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3)
     and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(9)
     and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(4)
     and  not z(3) and  not z(1) and z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and z(3) and  not z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1)
     and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
     and z(4) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and z(5) and z(4) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(2)
     and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(1))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(2) and z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(2) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(4) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(1))  or  (z(9) and z(8)
     and  not z(7) and z(6) and z(5) and z(4) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5)
     and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(2) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and z(5) and z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5)
     and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(1))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and  not z(4) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(1))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(4) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(1))  or  (z(9) and z(8)
     and  not z(7) and z(6) and  not z(5) and z(4) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(5) and z(4) and z(3)
     and z(1) and z(0));

db(3) <= ( not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  ( not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(6)
     and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and  not z(5) and z(3) and z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8)
     and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5)
     and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(6) and  not z(5)
     and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(4)
     and z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(8) and z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(9)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(8) and  not z(7) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (
    z(9) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5)
     and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(7)
     and  not z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(5) and  not z(4)
     and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7)
     and z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and z(5) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(1) and z(0))  or  (
    z(9) and  not z(7) and z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(3)
     and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and z(5) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7)
     and z(6) and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(4)
     and z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(2) and  not z(1))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(2)
     and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(1))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
     and  not z(2) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(2) and z(1))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(1))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(4)
     and z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2) and z(1))  or  (z(9) and z(8) and z(5)
     and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and z(1) and z(0));

db(2) <= (z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(8)
     and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6)
     and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3)
     and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and z(0))  or  ( not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(8) and z(7)
     and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and z(0))  or  (z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(8) and  not z(6) and z(5)
     and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(6) and z(5) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7)
     and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1)
     and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
     and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
    z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
     and  not z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(3) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(1))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and  not z(5) and  not z(4) and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(1))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and z(4) and z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(1))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(1))  or  (z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and z(4) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(1))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7)
     and z(6) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(2))  or  (
    z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and  not z(2))  or  ( not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(2))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(2))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(2))  or  (z(9)
     and z(8) and z(7) and z(6) and  not z(5) and z(2))  or  (z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and z(7) and z(6) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(2) and  not z(1) and z(0))  or  ( not z(9)
     and  not z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(2) and  not z(1) and z(0))  or  ( not z(9)
     and z(8) and z(7) and z(6) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(5)
     and z(3) and z(2) and z(1) and z(0));

db(1) <= ( not z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(8) and z(7) and z(6)
     and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1)
     and z(0))  or  (z(9) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(5) and z(4) and z(3) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(4) and  not z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and z(1))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(0))  or  (
     not z(9) and z(8) and z(6) and z(5) and  not z(3) and z(0))  or  (z(9) and  not z(8) and z(5) and  not z(4) and z(3) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and z(3)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (
    z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(2))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
     and z(2))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(2) and z(1) and z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and z(3) and  not z(2))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7)
     and  not z(6) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(5) and z(4) and z(3) and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  (
    z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(3) and  not z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(0))  or  ( not z(9) and z(8) and z(5)
     and  not z(4) and  not z(3) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2))  or  (z(8) and z(7)
     and z(6) and  not z(5) and z(3) and  not z(2))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(3) and z(2))  or  ( not z(9)
     and z(7) and z(6) and  not z(5) and z(3) and z(2))  or  (z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5)
     and  not z(3))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(0))  or  (z(9) and  not z(8)
     and z(6) and  not z(5) and  not z(3) and  not z(0))  or  ( not z(9) and z(8) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and z(3))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(9) and z(8) and z(6)
     and  not z(5) and z(3) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(3) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(3) and z(0));

db(0) <= (z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and z(4)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (z(9)
     and  not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(1)
     and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4)
     and z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (
    z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(8) and  not z(7)
     and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3)
     and  not z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (z(9) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
    z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
    z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(3) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(3) and z(1) and z(0))  or  ( not z(9)
     and z(8) and z(7) and z(6) and  not z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(3) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and z(4) and z(3) and  not z(2))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2))  or  ( not z(9) and  not z(8)
     and z(7) and z(5) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and z(3)
     and z(2) and z(0))  or  (z(9) and z(8) and z(7) and z(5) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and z(5) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(6) and z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(5) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8)
     and  not z(6) and z(5) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(5) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (z(8) and z(7) and  not z(6)
     and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(6) and  not z(5) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(6) and  not z(5) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(2) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(2)
     and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(2)
     and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(3) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(3) and z(2) and  not z(0))  or  (z(9)
     and  not z(8) and z(7) and  not z(6) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
     and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
     and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(1))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5)
     and  not z(3) and  not z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
     and z(3) and z(2));


					when "010" =>

db(4) <= (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(9) and z(8) and z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(3) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  (z(9)
     and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(4) and  not z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
     not z(9) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and z(1))  or  ( not z(9) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and  not z(1))  or  (
     not z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
     not z(9) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(1))  or  ( not z(9) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(9)
     and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(5)
     and z(3) and z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(5) and  not z(3) and  not z(1))  or  ( not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(3)
     and  not z(2) and  not z(1))  or  ( not z(9) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(9)
     and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(9) and z(8) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(5) and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(3)
     and  not z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (
    z(9) and  not z(8) and z(7) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(9) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1))  or  (
    z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and z(6) and z(5)
     and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
    z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(6) and z(5)
     and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6)
     and z(5) and z(4) and z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(3) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(5) and z(3)
     and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(8) and  not z(7)
     and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(5) and z(3) and z(1) and z(0))  or  ( not z(9)
     and  not z(8) and z(6) and  not z(5) and z(3) and z(1))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(1))  or  (
     not z(9) and  not z(8) and z(6) and z(5) and z(3) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and  not z(3)
     and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(0))  or  (z(9) and z(8) and z(7)
     and z(6) and z(5) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(8) and z(7) and  not z(6) and  not z(3) and z(1) and  not z(0))  or  (
     not z(8) and z(7) and z(6) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3)
     and z(2) and z(1))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(3) and  not z(1) and z(0))  or  ( not z(8) and  not z(7)
     and z(6) and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(3) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(3) and z(1) and z(0));

db(3) <= ( not z(9) and z(7) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1)
     and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7)
     and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5)
     and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(6) and z(5)
     and  not z(4) and z(3) and z(2) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(1))  or  (z(8) and z(7) and  not z(6) and z(5) and z(2) and z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2))  or  ( not z(9) and z(8) and z(6) and z(5) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(4) and  not z(3) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2))  or  ( not z(9) and z(8) and z(7) and  not z(5)
     and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(5) and  not z(4) and z(3) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
     and z(3) and z(2))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2))  or  (z(9) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(0))  or  ( not z(8) and  not z(7)
     and z(6) and z(5) and z(4) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5)
     and  not z(2))  or  ( not z(9) and z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(5)
     and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and  not z(4)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(0))  or  (
    z(8) and z(7) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(4)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(5) and z(2))  or  ( not z(9) and z(7) and  not z(6) and z(4) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8)
     and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and z(5) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(2))  or  ( not z(9) and  not z(8) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(6)
     and  not z(5) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4)
     and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(6) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(0))  or  (
     not z(9) and  not z(8) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(2))  or  ( not z(9)
     and  not z(8) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(6) and z(5) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(0))  or  (z(9) and z(8) and  not z(6)
     and z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(4) and  not z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(8) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7)
     and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(8) and  not z(7) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and  not z(4) and z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(4) and z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2) and z(1) and z(0))  or  (z(8) and  not z(7)
     and  not z(5) and  not z(4) and z(2) and z(1) and z(0));

db(2) <= (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7)
     and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7)
     and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(1))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5)
     and  not z(4) and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(1))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and z(4) and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(2)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(2)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(2) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and z(4) and  not z(3) and  not z(2))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2))  or  ( not z(8) and z(7)
     and  not z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2))  or  (
     not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(6)
     and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2))  or  (
     not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6)
     and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
     and z(2))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(2))  or  (z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(6) and z(4) and z(3) and z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3)
     and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
     and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(6) and  not z(4) and z(3) and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3)
     and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
     not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5)
     and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
     and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6)
     and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1)
     and z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7)
     and z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3)
     and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7)
     and z(6) and z(5) and z(3) and z(2) and z(1) and z(0));

db(1) <= ( not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(8) and z(7) and  not z(6) and z(5)
     and z(4) and  not z(3) and  not z(1))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  (
     not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and z(1))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  ( not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and z(3) and z(1))  or  (z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(8) and z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (
    z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(1))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1))  or  (
    z(9) and z(8) and  not z(6) and z(5) and  not z(2) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(2) and  not z(1))  or  (
    z(9) and z(8) and z(6) and  not z(5) and z(2) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(2) and  not z(1))  or  (
    z(9) and z(8) and  not z(6) and  not z(5) and  not z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(2) and z(1))  or  (
    z(9) and z(8) and z(6) and z(5) and z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(2) and z(1))  or  (
     not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(9) and z(7)
     and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(5) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and z(4) and  not z(3))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3))  or  ( not z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(2))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and  not z(4) and z(3))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2))  or  (z(9) and  not z(8)
     and z(7) and z(6) and z(5) and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and  not z(3))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and z(4) and  not z(3))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and z(3));

db(0) <= (z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7)
     and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7)
     and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7)
     and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
     and z(2) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(7)
     and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(4) and z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
     not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(4) and z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
     not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(8) and z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(1))  or  ( not z(9) and  not z(8)
     and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(5) and z(4) and z(3)
     and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(5)
     and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(8) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5)
     and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(2) and z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(2)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5)
     and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(4) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(0))  or  ( not z(9) and  not z(7) and  not z(6)
     and  not z(5) and  not z(3) and  not z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(3) and z(1))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and z(5) and  not z(1))  or  ( not z(9) and z(7) and z(6) and  not z(5) and z(3) and z(1))  or  (
    z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(7) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(0))  or  (z(9) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(4)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(7)
     and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2)
     and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(6) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and z(5) and z(4)
     and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(0))  or  (z(8)
     and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(6) and z(5)
     and z(4) and z(0))  or  (z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9)
     and z(8) and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(6) and  not z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
    z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(7) and z(5) and z(4)
     and z(3) and z(2) and z(1) and z(0));


					when "011" =>

db(4) <= ( not z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(5)
     and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(8)
     and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(4)
     and  not z(3) and  not z(1))  or  ( not z(9) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(4)
     and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(5)
     and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and z(4) and z(3) and  not z(2) and z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5)
     and z(4) and z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
    z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(7)
     and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2)
     and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(4)
     and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(6)
     and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and z(4) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9)
     and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(6) and z(5)
     and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5)
     and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(6) and  not z(5)
     and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6)
     and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1)
     and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and z(8)
     and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(8) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
     not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(8)
     and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(6) and  not z(5) and z(4)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(9) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
     and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(9)
     and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
    z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4)
     and  not z(3) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (
     not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(9)
     and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2)
     and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5)
     and z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
     and z(1))  or  (z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(4)
     and  not z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(8) and  not z(7) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3)
     and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(3) and  not z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
     and z(4) and z(3) and z(1))  or  ( not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6)
     and z(4) and z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(1))  or  ( not z(8)
     and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(4) and z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3)
     and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(3)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(3) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(3) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(1))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(5) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(1))  or  (z(9)
     and  not z(8) and z(7) and z(6) and z(5) and  not z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4) and z(2)
     and z(1) and z(0));

db(3) <= ( not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
     not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(4)
     and z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
    z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5)
     and z(4) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(9) and  not z(8) and  not z(6) and z(5)
     and z(4) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(3) and z(2) and  not z(0))  or  (z(9)
     and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(3)
     and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(3) and z(2) and  not z(0))  or  ( not z(9)
     and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and z(5) and z(4) and  not z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and z(3) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and z(3) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3)
     and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(3) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(1) and z(0))  or  (
     not z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and z(4)
     and z(3) and  not z(2) and z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5)
     and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(8) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
     not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
    z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(4)
     and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(1))  or  (z(9)
     and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3) and z(1))  or  (z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and  not z(4) and z(1))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
     not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(1))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and z(3) and  not z(1))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(2))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(2))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2))  or  ( not z(9) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (
    z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2))  or  ( not z(8) and z(7) and z(6) and z(5) and z(3) and z(2))  or  (
    z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(3)
     and  not z(2))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(8) and z(7) and z(6)
     and z(5) and z(3) and  not z(2))  or  (z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(9)
     and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(1) and z(0));

db(2) <= ( not z(9) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
     and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(9)
     and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and z(5) and z(4) and  not z(3)
     and  not z(1) and z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6)
     and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1)
     and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(7)
     and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and  not z(3) and  not z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(6)
     and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(4) and z(2) and z(1))  or  ( not z(9)
     and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  ( not z(9) and z(8) and z(6) and  not z(5)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(2) and  not z(1))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1))  or  (z(9)
     and  not z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(6)
     and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(2) and z(1)
     and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4)
     and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
    z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(3) and z(2)
     and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and z(2)
     and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4)
     and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  (z(9) and z(8)
     and z(6) and  not z(5) and z(4) and z(2) and z(1))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5)
     and  not z(4) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(2) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7)
     and z(6) and z(5) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5)
     and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(1) and z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(5) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(2))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and z(2) and  not z(1))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(9) and  not z(8)
     and z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and z(3)
     and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(1)
     and z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4)
     and  not z(3) and z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and z(1) and z(0));

db(1) <= (z(9) and  not z(8) and z(7) and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(2))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (
     not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6)
     and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2)
     and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9)
     and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and z(1))  or  (z(9) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(3) and z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(1))  or  (z(9) and  not z(8) and z(6)
     and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  (
     not z(9) and z(8) and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(3) and z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5)
     and z(3) and  not z(1))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and z(3)
     and z(1) and  not z(0))  or  (z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1))  or  ( not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
     and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(3)
     and  not z(1) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5)
     and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(3) and z(1) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2))  or  ( not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (
     not z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (
     not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1))  or  (z(9) and  not z(8) and  not z(6) and  not z(5)
     and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5)
     and z(3) and z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(8) and z(7)
     and  not z(6) and z(5) and z(4) and z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and z(5) and z(3) and  not z(1) and  not z(0))  or  (
     not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and z(1))  or  ( not z(9) and z(8) and z(7) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5)
     and z(4) and  not z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2))  or  (z(9) and z(8)
     and z(7) and z(6) and z(5) and z(4) and z(2))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2))  or  (
    z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2))  or  (z(9) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(8)
     and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2))  or  (
    z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1)
     and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(1) and z(0))  or  (
    z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(4)
     and z(1) and z(0));

db(0) <= (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3)
     and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5)
     and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
     and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
     and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
     and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
     and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
     and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
     and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6)
     and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
     and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1)
     and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1)
     and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2)
     and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8)
     and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3)
     and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1)
     and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4)
     and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
     and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
     and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0));


					when "100" =>
 
db(4) <= ( not z(9) and  not z(8) and  not z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (z(8) and  not z(6) and  not z(5) and z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(7)
     and z(6) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(5) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(5) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(6) and  not z(5)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(8) and z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(3)
     and z(2) and  not z(0))  or  (z(8) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and z(5) and  not z(3) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3))  or  (
    z(9) and z(8) and  not z(7) and  not z(5) and  not z(3) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5)
     and  not z(3) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and z(3) and  not z(0))  or  (z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(7) and z(5) and  not z(3) and z(2) and z(1)
     and z(0))  or  (z(9) and z(7) and  not z(5) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3))  or  ( not z(9) and  not z(8) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(5) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(3) and z(2))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(0))  or  (z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(3) and z(0))  or  ( not z(9) and  not z(8) and z(5) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and  not z(3) and z(2))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(0))  or  (
    z(9) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(6) and z(5) and  not z(3) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5)
     and  not z(3) and  not z(2))  or  ( not z(9) and z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(6)
     and z(5) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(3) and  not z(2))  or  ( not z(9)
     and z(8) and  not z(6) and z(5) and z(3) and  not z(0))  or  (z(9) and  not z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(6) and  not z(5)
     and z(3) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(7) and z(6) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(6) and z(5) and z(3) and  not z(1)
     and  not z(0))  or  (z(7) and z(6) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(6) and  not z(5)
     and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(6) and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(8) and  not z(7)
     and z(6) and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(3)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(7) and  not z(6)
     and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(6)
     and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(6) and z(5) and z(3) and  not z(1) and z(0))  or  ( not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(6) and  not z(5) and  not z(3) and z(1) and z(0))  or  (z(9)
     and  not z(6) and z(5) and  not z(3) and z(1) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(6) and z(5) and z(3) and z(1) and z(0))  or  ( not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(8) and z(7)
     and z(6) and z(5) and z(3) and z(2) and z(1) and z(0));

db(3) <= ( not z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
     and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and z(6) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1)
     and z(0))  or  ( not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(8) and z(7) and  not z(5)
     and z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(5)
     and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  (z(9)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5)
     and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
     and z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4)
     and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(2))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(5) and z(3) and z(2))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and  not z(2))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(2))  or  (z(9) and  not z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4) and z(3))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and  not z(4) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(3) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5)
     and  not z(3) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(0))  or  (z(9) and z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and z(5) and z(4) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(3) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(3)
     and  not z(2))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(0))  or  (
     not z(9) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6)
     and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(3) and  not z(2) and  not z(0))  or  (
    z(9) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and z(3) and  not z(2))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(2))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(2))  or  (z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3)
     and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(3) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(4) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9)
     and z(7) and  not z(6) and z(5) and z(3) and  not z(2))  or  (z(8) and z(7) and z(6) and z(5) and z(3) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(5) and z(4) and z(0))  or  (z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and z(2))  or  (z(9) and z(8)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
     and z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and z(3) and z(2))  or  ( not z(9) and z(8) and z(6) and z(5)
     and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1)
     and z(0));

db(2) <= (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8)
     and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(9)
     and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3)
     and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and  not z(4) and z(2) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2)
     and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and z(6) and  not z(5) and  not z(4)
     and z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(1) and z(0))  or  (z(9) and z(8)
     and  not z(6) and z(5) and z(4) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(1) and z(0))  or  ( not z(9) and z(8) and z(6)
     and  not z(5) and z(4) and  not z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(2)
     and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(1))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(3))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(4)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(5) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(0))  or  (
    z(9) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(6) and z(5) and  not z(3) and  not z(1)
     and  not z(0))  or  (z(9) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(6) and z(5) and z(3)
     and  not z(1) and  not z(0))  or  (z(9) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(6)
     and z(5) and  not z(3) and z(1) and  not z(0))  or  (z(9) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  ( not z(9)
     and z(6) and z(5) and z(3) and z(1) and  not z(0))  or  (z(9) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (
     not z(9) and  not z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (z(9) and  not z(6) and  not z(5) and z(3) and  not z(1)
     and z(0))  or  ( not z(9) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(6) and  not z(5) and  not z(3)
     and z(1) and z(0))  or  ( not z(9) and z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (z(9) and z(6) and  not z(5)
     and z(3) and z(1) and z(0))  or  ( not z(9) and  not z(6) and z(5) and z(3) and z(1) and z(0));

db(1) <= ( not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5)
     and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3)
     and z(2) and z(1))  or  ( not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(8) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4)
     and z(3) and z(2) and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (
     not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(5) and z(4) and z(2) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(0))  or  (z(8) and  not z(7)
     and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6)
     and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
    z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3)
     and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(8) and z(7) and z(6) and z(5) and z(4)
     and z(3) and z(2) and  not z(1))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
    z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(1))  or  (z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (
     not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(8) and z(7) and  not z(6) and z(5)
     and z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(9)
     and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(8) and  not z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (
     not z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(1) and z(0))  or  (
    z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(5)
     and z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(1) and z(0))  or  (
    z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(7)
     and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and z(1))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
     not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(1))  or  (z(9) and  not z(8)
     and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(6) and z(4) and  not z(3) and  not z(2)
     and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(1))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1))  or  (z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2)
     and  not z(1))  or  (z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(1))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5)
     and z(3) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1))  or  (z(9) and z(8)
     and z(7) and z(6) and z(5) and  not z(4) and z(1))  or  ( not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(6)
     and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and z(2) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(1))  or  ( not z(8) and z(7)
     and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
     and z(3))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1))  or  (z(9) and  not z(8) and  not z(6)
     and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3)
     and  not z(2) and z(1))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and z(4)
     and z(3) and z(2) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5)
     and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(4)
     and  not z(3) and  not z(2) and z(1))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0));

db(0) <= ( not z(9) and  not z(8) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and  not z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(8)
     and z(7) and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(5) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6)
     and z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(5) and z(3) and z(2) and z(1)
     and z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7)
     and z(6) and  not z(5) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (
     not z(8) and  not z(7) and  not z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
     and  not z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (z(8) and z(7) and z(6)
     and  not z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(2) and  not z(1) and z(0))  or  (z(8)
     and z(7) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  (
     not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (
     not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and z(5) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and z(4) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4)
     and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (z(8)
     and  not z(7) and z(6) and z(5) and z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  (z(9) and  not z(7)
     and z(6) and  not z(5) and  not z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and z(3))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3))  or  (
    z(8) and  not z(7) and z(5) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(1)
     and z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(6)
     and z(5) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(5) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(2)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(0))  or  (z(8) and  not z(7) and z(6)
     and z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(5) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5)
     and z(3))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3))  or  (z(9) and z(7)
     and  not z(6) and  not z(5) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(6) and z(5) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(5) and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(6) and  not z(5) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(2)
     and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(4) and z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6)
     and z(5) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(2) and  not z(1) and z(0))  or  (z(9)
     and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and z(1) and z(0))  or  ( not z(9)
     and z(8) and  not z(7) and z(5) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0));


					when "101" =>

db(4) <= ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(4) and  not z(2) and z(1))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1))  or  (
    z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6)
     and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7)
     and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
    z(8) and z(7) and  not z(6) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5)
     and  not z(3) and z(2) and z(1) and z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
    z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(4) and z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2)
     and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(6) and z(5) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5)
     and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7)
     and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(2)
     and z(0))  or  (z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3)
     and  not z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(4)
     and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
    z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  (z(9) and z(8) and z(7) and z(5) and z(4)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5)
     and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (
    z(9) and z(8) and z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5)
     and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and z(2) and  not z(1))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2)
     and  not z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(3) and  not z(2) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(2) and z(1))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4)
     and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(5)
     and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(5) and z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2)
     and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(7) and  not z(6)
     and z(5) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(2)
     and  not z(1))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(4) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and  not z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(9) and  not z(7)
     and z(6) and  not z(5) and z(4) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(2) and z(1))  or  (
     not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(3) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(2) and  not z(1))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and  not z(4) and z(2) and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(2) and z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5)
     and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(2) and  not z(1))  or  ( not z(9) and z(8)
     and z(7) and z(6) and  not z(5) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(2) and  not z(1))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(2) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(2) and z(1))  or  (z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5)
     and z(3) and  not z(1))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2)
     and z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3) and z(1))  or  (z(9) and z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and  not z(4) and z(2) and  not z(1))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  (
     not z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and z(1));

db(3) <= (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(9) and z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(9)
     and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and  not z(4) and z(3) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(0))  or  (
    z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(6) and  not z(5) and z(4)
     and z(3) and  not z(1) and  not z(0))  or  (z(9) and z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(4) and z(3) and  not z(1)
     and  not z(0))  or  (z(9) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(6) and  not z(5) and z(4) and z(3)
     and z(1) and  not z(0))  or  (z(9) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(4) and z(3) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(4) and z(3) and z(1) and  not z(0))  or  (
     not z(9) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(7) and z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(4)
     and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (
     not z(9) and z(8) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(4) and  not z(3)
     and z(2) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(5) and  not z(4) and z(3) and z(2)
     and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7)
     and z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(0))  or  ( not z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(7)
     and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and z(5)
     and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(7) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9)
     and z(8) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(4) and  not z(3)
     and z(2) and z(0))  or  ( not z(9) and z(7) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7)
     and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(4) and z(3) and z(2) and z(0))  or  (
     not z(9) and z(8) and z(6) and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(5) and z(4) and  not z(3) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(5) and z(4))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(2))  or  ( not z(9)
     and z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(2))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(2))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(3) and z(2))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and z(2))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and z(1))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  (z(8)
     and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
     and  not z(3) and z(1))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and z(3) and z(1))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1))  or  (z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(3) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (
     not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and z(3) and  not z(1))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4)
     and z(3) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(5) and z(4) and z(3) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1));

db(2) <= ( not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(2) and  not z(1))  or  (z(9) and z(8) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (z(8) and z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3)
     and z(2) and  not z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(8)
     and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(5) and z(4)
     and  not z(3) and z(2) and  not z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
    z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2)
     and  not z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(9)
     and z(8) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3)
     and  not z(1) and  not z(0))  or  (z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
    z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7)
     and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3)
     and  not z(2) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and z(7)
     and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5)
     and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1)
     and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5)
     and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6)
     and  not z(5) and z(2) and  not z(1) and z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(2) and z(1) and z(0))  or  (z(8) and z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(5) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(5) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(4) and z(0))  or  (
    z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(0))  or  (z(9) and z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(0))  or  (z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and z(3))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3)
     and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(3))  or  (z(9) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2)
     and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3))  or  ( not z(9) and z(8) and z(7)
     and z(6) and z(5) and z(1))  or  (z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  ( not z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
     not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(9) and z(7) and z(6) and z(5)
     and z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0));

db(1) <= ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(5) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(2) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and z(5) and z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5)
     and  not z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(2) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(2)
     and z(0))  or  ( not z(9) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(4)
     and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9)
     and  not z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
    z(9) and z(6) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
    z(9) and  not z(8) and z(4) and z(3) and z(2) and  not z(0))  or  (z(9) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (
    z(9) and z(8) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(4) and z(3) and  not z(2) and z(0))  or  (
    z(9) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
     not z(9) and z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(6) and  not z(4) and z(3) and z(2) and z(0))  or  (
     not z(9) and z(8) and z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(2))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3))  or  ( not z(9) and  not z(8)
     and z(7) and z(5) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9)
     and  not z(7) and  not z(6) and  not z(5) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
     and  not z(3))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3))  or  ( not z(9) and z(7) and  not z(6)
     and z(5) and  not z(2) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(3))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3))  or  (z(9) and z(8)
     and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and z(2)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3))  or  ( not z(9) and  not z(8)
     and z(7) and  not z(6) and z(5) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
     and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6)
     and z(5) and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(5) and z(2)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(4)
     and z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and z(0))  or  (z(9) and z(8) and z(7) and  not z(5) and  not z(2) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7)
     and z(5) and  not z(2) and z(0))  or  (z(9) and z(7) and  not z(6) and  not z(5) and  not z(2) and z(0))  or  (z(8) and z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5) and  not z(2)
     and z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(2)
     and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and z(2))  or  ( not z(9) and z(7) and z(6) and z(5) and z(2) and z(0))  or  (z(8) and z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
     and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and z(2) and z(0))  or  ( not z(9) and z(8) and z(7)
     and z(5) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (
    z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0));

db(0) <= ( not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8)
     and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
     and  not z(1))  or  (z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
     and  not z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(8) and  not z(7) and  not z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2)
     and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(8)
     and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1))  or  (z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1))  or  (
     not z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(6) and  not z(5)
     and  not z(4) and z(3) and z(1))  or  ( not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(9)
     and  not z(8) and z(6) and z(5) and z(4) and z(3) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(4) and  not z(3)
     and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(9) and z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4)
     and  not z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and z(4)
     and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(9) and z(8)
     and  not z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  (z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and z(0))  or  (
    z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5) and z(4)
     and z(2) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (z(9) and  not z(7)
     and z(6) and  not z(5) and  not z(4) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3)
     and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(0))  or  (z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and  not z(3) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and z(3) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(0))  or  (z(9) and z(8)
     and z(7) and z(6) and z(5) and z(3) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(2))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(3))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3))  or  (z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(3))  or  (z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(1))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4)
     and  not z(3) and  not z(1))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(9)
     and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(8)
     and z(7) and z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(4) and  not z(3) and z(1))  or  ( not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  ( not z(9) and z(8)
     and  not z(7) and z(4) and  not z(3) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(1))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(4) and z(3) and z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(1))  or  (
     not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(1))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4)
     and z(3) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1));


					when "110" =>

db(4) <= ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8)
     and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5)
     and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and z(4) and  not z(2) and z(1)
     and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(4) and z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and z(4)
     and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5)
     and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  (z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4)
     and z(3) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  ( not z(9)
     and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and  not z(4) and z(3) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(3) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and  not z(3) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(0))  or  ( not z(7) and z(6)
     and  not z(5) and z(4) and  not z(2) and  not z(1))  or  ( not z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1))  or  (
     not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and z(4) and z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  (z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1))  or  ( not z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
     not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1))  or  ( not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(1))  or  (z(9) and z(8) and z(7) and z(6)
     and z(5) and z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  (z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(3) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1))  or  ( not z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(3) and z(1))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1))  or  (z(9) and  not z(8) and  not z(7) and z(5)
     and z(4) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(2) and  not z(1))  or  (
    z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(5) and  not z(4)
     and z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(2))  or  ( not z(9) and z(8)
     and z(7) and z(6) and z(5) and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and z(1))  or  (
     not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(5)
     and  not z(4) and z(2) and z(1))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and z(1))  or  (z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and z(2))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(4) and z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2))  or  ( not z(9) and z(8)
     and z(7) and z(6) and z(5) and  not z(4) and  not z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4)
     and  not z(2))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5)
     and  not z(4) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(6) and z(5) and  not z(4) and  not z(2) and z(1))  or  ( not z(7)
     and  not z(6) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(7)
     and  not z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and z(4) and z(2) and z(1))  or  (
     not z(9) and z(8) and z(6) and z(5) and z(4) and z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4)
     and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(6) and  not z(5)
     and  not z(4) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(7) and z(6) and z(4) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(7) and z(6) and  not z(4) and z(2)
     and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  ( not z(9) and z(8)
     and  not z(6) and  not z(5) and z(4) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4)
     and z(2) and z(1) and z(0));

db(3) <= (z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
    z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(7) and  not z(6) and  not z(5) and z(4)
     and  not z(3) and  not z(1) and  not z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
    z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and z(4) and  not z(3)
     and  not z(1) and  not z(0))  or  ( not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(7)
     and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(7) and  not z(6) and z(5) and  not z(4) and z(3)
     and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  (z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1)
     and  not z(0))  or  ( not z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and  not z(0))  or  (z(7) and z(6) and z(5)
     and z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (
    z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  (z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1)
     and  not z(0))  or  ( not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(7) and z(6) and z(5)
     and z(4) and  not z(3) and z(1) and  not z(0))  or  (z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
     not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(7) and  not z(6) and z(5) and  not z(4)
     and z(3) and z(1) and  not z(0))  or  (z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1)
     and  not z(0))  or  (z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5)
     and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (
    z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(1) and z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  (z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1)
     and z(0))  or  ( not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(7) and z(6) and z(5)
     and z(4) and  not z(3) and  not z(1) and z(0))  or  (z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
     not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(7) and  not z(6) and z(5) and  not z(4)
     and z(3) and  not z(1) and z(0))  or  (z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(1)
     and z(0))  or  (z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(7) and z(6) and z(5)
     and z(4) and z(3) and  not z(1) and z(0))  or  (z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  (
     not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(3) and z(1) and z(0))  or  (z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(7)
     and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1)
     and z(0))  or  (z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(7) and z(6) and z(5)
     and z(4) and  not z(3) and z(1) and z(0))  or  ( not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (
    z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(7) and  not z(6) and z(5) and  not z(4) and z(3)
     and z(1) and z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  (z(7) and  not z(6)
     and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  ( not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(1) and z(0))  or  (
     not z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1) and z(0))  or  (z(7) and z(6) and z(5) and z(4) and z(3)
     and z(1) and z(0));

db(2) <= (z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and z(8) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(5) and z(4)
     and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9)
     and z(8) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(6) and z(5)
     and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and z(0))  or  ( not z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9)
     and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(4)
     and z(3) and z(2) and z(0))  or  (z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(8) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1)
     and z(0))  or  ( not z(8) and z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(8) and z(6)
     and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(6) and z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(9)
     and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(8) and z(7) and z(6) and z(5)
     and z(4) and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(3) and z(2) and z(1)
     and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(4) and z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(1)
     and z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2))  or  ( not z(8) and z(7) and  not z(5) and  not z(4) and z(3)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3)
     and z(2))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(9) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3)
     and z(2) and z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(1) and z(0))  or  (z(9) and z(7)
     and  not z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  (z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  (z(9) and z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(6) and  not z(5) and z(3)
     and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  (z(9) and z(7)
     and z(6) and  not z(5) and z(3) and z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(2)
     and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(7)
     and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5)
     and z(3) and z(2) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (
    z(8) and  not z(7) and z(6) and z(5) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and z(3)
     and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(1))  or  ( not z(9) and z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(3) and  not z(2) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(2))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(2))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(3) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and z(4))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(1))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(3))  or  ( not z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6)
     and z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (
    z(9) and z(7) and  not z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and  not z(3)
     and z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and z(6) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(4) and z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and z(6) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and z(5) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(5) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1)
     and z(0));

db(1) <= ( not z(9) and  not z(8) and  not z(4) and  not z(3))  or  (z(9) and z(8) and  not z(4) and  not z(3))  or  (z(9) and  not z(8)
     and z(4) and  not z(3))  or  ( not z(9) and z(8) and z(4) and  not z(3))  or  (z(9) and  not z(8) and  not z(4) and z(3))  or  (
     not z(9) and z(8) and  not z(4) and z(3))  or  ( not z(9) and  not z(8) and z(4) and z(3))  or  (z(9) and z(8) and z(4)
     and z(3));

db(0) <= (z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and z(8) and  not z(6) and z(5) and z(4) and z(3) and z(2)
     and z(1))  or  ( not z(9) and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1))  or  ( not z(9)
     and  not z(8) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(6) and z(5)
     and z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9)
     and z(8) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and  not z(0))  or  (z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(0))  or  (z(8)
     and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
     not z(9) and  not z(8) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(6)
     and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2)
     and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(8)
     and  not z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(0))  or  ( not z(8) and z(6) and  not z(5) and z(4) and  not z(3)
     and z(2) and z(0))  or  ( not z(9) and z(6) and  not z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and z(5) and  not z(2) and  not z(1))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and z(2) and z(1))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and  not z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(3) and  not z(1))  or  (z(9)
     and  not z(8) and z(7) and  not z(6) and z(5) and z(3) and  not z(1))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(3)
     and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and z(3) and z(1))  or  (z(9) and z(7) and  not z(6)
     and  not z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (
    z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  ( not z(8) and z(7)
     and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(1)
     and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(3) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7)
     and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(3) and  not z(1) and z(0))  or  (
    z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and z(3)
     and z(2) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  (z(8) and z(7)
     and z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2)
     and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(8) and z(7) and z(6)
     and  not z(5) and  not z(3) and z(2) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  (
    z(8) and z(7) and z(6) and z(5) and  not z(4) and z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and z(4) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5)
     and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(1))  or  (z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(5) and  not z(3))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3))  or  (z(9)
     and  not z(8) and  not z(7) and z(6) and  not z(5) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(5) and z(0))  or  (
    z(9) and z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and z(7) and z(6) and z(5) and  not z(4)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9)
     and z(7) and z(6) and z(5) and z(4) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and z(2)
     and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(8)
     and z(5) and z(4) and z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(5) and  not z(3) and z(1) and  not z(0))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(4) and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(3) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7)
     and  not z(6) and  not z(4) and z(3) and z(2) and z(1))  or  (z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1)
     and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(3) and z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(3) and z(1) and z(0));


					when "111" =>

db(4) <= (z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7)
     and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(8) and z(7)
     and  not z(6) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(7) and  not z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(5)
     and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8)
     and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(5) and  not z(4) and z(3) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9)
     and z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6)
     and  not z(4) and  not z(3) and z(2) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9)
     and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(6) and  not z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(9) and z(8) and z(7) and z(5)
     and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
     and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1))  or  (z(8) and z(7) and z(6) and  not z(4)
     and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(5)
     and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2)
     and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(1))  or  (z(9) and  not z(8)
     and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and z(4) and z(3)
     and z(2) and z(1))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6)
     and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(4) and z(3) and  not z(2) and z(1)
     and z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and z(2) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  ( not z(9)
     and z(8) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and z(3) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(6) and  not z(4) and  not z(3) and  not z(2)
     and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and z(4) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(2))  or  ( not z(9) and z(8) and  not z(6) and z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and z(8) and  not z(6) and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2))  or  ( not z(9) and z(8) and  not z(7) and  not z(5)
     and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(5) and z(4)
     and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(4) and  not z(3)
     and z(2) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2)
     and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8) and  not z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1))  or  (
    z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(9) and  not z(8) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(5) and z(4) and z(3) and z(2) and z(1))  or  (z(9) and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1))  or  (z(9) and z(7)
     and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(5) and  not z(4) and z(3) and z(2)
     and z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1))  or  (z(9) and z(7) and z(6) and  not z(4) and z(3)
     and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(5) and z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(8) and z(7) and z(5) and  not z(4) and z(3) and  not z(2)
     and z(1))  or  (z(9) and  not z(7) and  not z(6) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3)
     and z(2) and  not z(1))  or  (z(9) and z(8) and  not z(7) and z(5) and z(4) and  not z(3) and  not z(2) and z(1))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1))  or  (z(9) and  not z(7) and z(6) and  not z(4) and z(3)
     and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1))  or  (z(9) and  not z(7) and z(6) and z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  (
     not z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(7) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(0))  or  (
     not z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(6) and z(4)
     and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(5) and  not z(4) and z(3)
     and z(2) and z(0))  or  ( not z(9) and  not z(7) and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  ( not z(8) and  not z(7)
     and z(6) and  not z(5) and  not z(3) and  not z(2))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(2))  or  (
    z(9) and z(8) and  not z(6) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6)
     and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and  not z(2)
     and z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (
    z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7)
     and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(4)
     and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
    z(9) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6)
     and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and z(7) and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7) and z(5)
     and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(6) and  not z(4) and  not z(3) and  not z(2) and z(1)
     and z(0))  or  (z(9) and z(8) and z(6) and z(4) and  not z(3) and z(2) and z(1) and z(0));

db(3) <= ( not z(9) and z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(0))  or  (z(9) and  not z(7) and z(6)
     and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2)
     and z(1) and z(0))  or  ( not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(7) and  not z(6)
     and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2)
     and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(5) and  not z(3) and z(2) and  not z(0))  or  (z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(4)
     and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
     not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(5) and  not z(4)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(6) and  not z(5)
     and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and  not z(8) and z(6) and z(5) and z(3) and z(2) and  not z(0))  or  (z(9)
     and z(8) and z(7) and z(6) and z(5) and z(4) and z(1) and z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(4)
     and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(3)
     and z(2) and z(0))  or  (z(8) and z(7) and z(6) and z(5) and  not z(4) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(1)
     and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(1) and  not z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(4) and z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(4) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(1) and z(0))  or  (
    z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(5) and  not z(2) and z(0))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and z(2)
     and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(9) and z(8)
     and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(3)
     and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(0))  or  (z(9)
     and  not z(8) and z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(3) and z(2) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(4) and  not z(3) and  not z(2) and  not z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and  not z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and z(3) and z(2) and z(0))  or  ( not z(9)
     and  not z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(3)
     and  not z(2) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(7)
     and  not z(6) and  not z(5) and z(3) and  not z(2) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2)
     and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(3) and z(2) and  not z(0))  or  (z(8) and  not z(7) and z(6)
     and z(5) and z(3) and z(2) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(0))  or  (
    z(8) and  not z(7) and z(6) and z(5) and  not z(3) and  not z(2) and z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(3)
     and z(2) and z(0))  or  (z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(7) and z(6) and  not z(5) and  not z(2))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(2))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(2) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and z(3)
     and  not z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and z(5) and z(2))  or  ( not z(8) and z(7) and  not z(6)
     and z(5) and  not z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(2))  or  (
    z(9) and z(8) and z(7) and z(6) and  not z(5) and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6) and z(5)
     and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2))  or  (z(9) and z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and  not z(2))  or  (z(9) and z(8) and z(7) and  not z(6) and z(5) and z(4) and z(2))  or  (
    z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2))  or  (z(9) and  not z(8) and z(7) and z(6) and z(5)
     and z(4) and  not z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and z(2))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2))  or  ( not z(8) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4))  or  ( not z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(4))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4))  or  (z(8) and  not z(7) and z(6) and  not z(5)
     and z(4) and  not z(2))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4))  or  (z(8) and  not z(7)
     and  not z(6) and z(5) and  not z(4) and z(2))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(2));

db(2) <= (z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  (
    z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8) and z(7) and z(5)
     and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and z(2)
     and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
    z(9) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(6) and z(5) and z(4)
     and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and  not z(7)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and z(5) and z(4)
     and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9)
     and  not z(8) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(5) and z(4)
     and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  ( not z(8) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(8)
     and z(7) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(8) and  not z(6) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(8) and z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(5) and z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(8) and z(6)
     and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3)
     and  not z(2) and z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(5) and  not z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and z(5)
     and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(5) and z(4) and  not z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(8)
     and  not z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5)
     and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  (z(9) and z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(8)
     and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5)
     and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2)
     and  not z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  (z(8)
     and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6)
     and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9)
     and z(8) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and  not z(5) and  not z(4) and z(3)
     and z(2) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and z(2) and z(1))  or  (z(9) and z(6)
     and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
     and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(4) and z(2) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7)
     and  not z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and  not z(2)
     and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(2) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and  not z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6)
     and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and z(5) and z(4) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(7) and  not z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6)
     and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(7) and z(6)
     and z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(7)
     and z(6) and z(5) and z(4) and z(2) and z(1) and z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(7) and z(6) and z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(2) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and  not z(2))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(2))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(0))  or  (
    z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(2) and  not z(1))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(2) and z(1))  or  (
    z(9) and z(8) and  not z(6) and z(5) and z(2) and z(1))  or  (z(9) and  not z(8) and z(6) and z(5) and z(2) and  not z(1))  or  (
    z(9) and z(8) and  not z(6) and z(5) and  not z(2) and  not z(1))  or  (z(9) and z(8) and z(6) and  not z(5) and  not z(2) and  not z(1))  or  (
    z(9) and  not z(8) and z(6) and z(5) and  not z(2) and z(1))  or  (z(9) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3)
     and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(6) and z(5)
     and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(4) and  not z(2) and  not z(1)
     and  not z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7)
     and  not z(6) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and  not z(4) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(2) and  not z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(5)
     and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and z(8) and  not z(7) and z(5) and z(4) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(7) and z(6) and z(5) and  not z(4)
     and z(3) and  not z(2) and z(1) and  not z(0))  or  (z(9) and  not z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(5) and z(4) and z(2) and z(1) and  not z(0))  or  (z(9) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1)
     and  not z(0))  or  (z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(9) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2)
     and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(2) and  not z(1) and z(0))  or  ( not z(9)
     and z(8) and  not z(7) and  not z(5) and  not z(4) and z(2) and  not z(1) and z(0))  or  (z(9) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and z(4) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(5) and  not z(4) and  not z(2) and z(1) and z(0))  or  ( not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(2) and z(1) and z(0))  or  (
     not z(8) and  not z(7) and z(6) and z(4) and  not z(2) and z(1) and z(0))  or  (z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(2) and z(1) and z(0))  or  (z(9) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (
    z(8) and z(7) and z(6) and  not z(4) and z(2) and z(1) and z(0))  or  (z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(2) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(2) and z(1) and z(0))  or  (z(9) and z(6) and  not z(5) and  not z(4)
     and z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and z(1)
     and z(0));

db(1) <= (z(9) and  not z(8) and  not z(6) and  not z(5) and z(1) and  not z(0))  or  (z(9) and z(8) and z(6) and  not z(5) and z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and z(1) and  not z(0))  or  (z(9) and  not z(8) and z(6) and z(5)
     and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(1) and z(0))  or  (z(9) and z(8) and z(6)
     and  not z(5) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(1) and z(0))  or  (z(9) and  not z(8)
     and z(6) and z(5) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(4) and  not z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and  not z(4) and  not z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and  not z(2))  or  ( not z(9)
     and z(8) and z(6) and  not z(5) and  not z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4)
     and  not z(2))  or  ( not z(9) and z(8) and  not z(6) and z(5) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(6)
     and z(5) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(2))  or  (z(9)
     and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2))  or  ( not z(9) and z(7) and z(4) and  not z(3) and  not z(1)
     and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2))  or  (z(9) and  not z(8) and z(7)
     and  not z(6) and z(5) and z(4) and  not z(2))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2))  or  (
     not z(9) and z(7) and  not z(4) and z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(7) and z(4) and z(3) and  not z(1)
     and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(2))  or  (z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and  not z(4) and z(2))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2))  or  (
    z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5)
     and z(4) and z(2))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and z(2))  or  (z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and z(2))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(2))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(5) and z(4) and  not z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and z(1)
     and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and z(1) and  not z(0))  or  ( not z(9)
     and z(8) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(5) and z(4) and  not z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4)
     and z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6) and  not z(5)
     and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(1) and z(0))  or  ( not z(9)
     and  not z(7) and  not z(4) and  not z(3) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(6) and  not z(5) and z(1) and z(0))  or  (
     not z(9) and z(8) and z(6) and  not z(5) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(6) and z(5) and z(1) and z(0))  or  (
     not z(9) and  not z(8) and z(6) and z(5) and z(1) and z(0))  or  ( not z(9) and z(7) and z(4) and  not z(3) and z(1) and z(0))  or  (
     not z(9) and z(7) and  not z(4) and z(3) and z(1) and z(0))  or  ( not z(9) and  not z(7) and z(4) and z(3) and z(1) and z(0));

db(0) <= ( not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9)
     and  not z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(8) and  not z(7) and  not z(6)
     and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(8) and  not z(7)
     and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(8) and z(7) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and  not z(4) and z(3)
     and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8)
     and  not z(7) and z(6) and z(5) and z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(7) and z(6) and  not z(5) and z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(0))  or  ( not z(9) and  not z(8)
     and z(7) and z(5) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(8) and z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and z(2) and  not z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(8) and z(7) and  not z(6)
     and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2)
     and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(5) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(9) and z(7) and z(6)
     and z(5) and z(3) and z(2) and  not z(1) and  not z(0))  or  (z(9) and z(8) and z(7) and z(5) and  not z(3) and z(2) and z(1)
     and  not z(0))  or  ( not z(9) and z(8) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(5) and z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and  not z(2) and  not z(1)
     and z(0))  or  ( not z(8) and z(7) and  not z(5) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5)
     and z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and  not z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and z(4) and z(3) and  not z(2) and z(1)
     and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(7) and  not z(6) and  not z(5) and  not z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(5)
     and  not z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  (z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and  not z(5) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(5)
     and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(7) and  not z(6) and  not z(5) and z(4) and z(3) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(8) and  not z(7)
     and z(6) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(5) and  not z(4)
     and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(5) and  not z(4) and z(3) and z(2) and z(1)
     and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (
    z(8) and  not z(7) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and z(6)
     and z(4) and  not z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(7) and  not z(6) and z(5) and z(4) and z(3) and  not z(2)
     and  not z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and z(4) and z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8)
     and  not z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(8) and z(7) and  not z(6) and z(4)
     and  not z(3) and  not z(2) and z(1) and  not z(0))  or  (z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and z(6) and  not z(4) and  not z(3) and  not z(2) and  not z(1) and z(0))  or  (z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and z(7) and z(6) and  not z(4) and z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6) and  not z(4) and z(3) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and  not z(2) and z(1) and z(0))  or  (z(8)
     and  not z(7) and  not z(6) and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and z(6)
     and z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3) and  not z(2)
     and z(1) and z(0))  or  ( not z(9) and z(7) and z(6) and  not z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(8) and z(7) and  not z(6) and z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and z(5) and z(4) and  not z(3)
     and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and z(7) and z(6) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  ( not z(7) and z(6) and  not z(5)
     and  not z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4) and  not z(3)
     and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and  not z(1) and z(0))  or  (
     not z(9) and z(7) and  not z(6) and z(5) and z(4) and z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6) and  not z(4)
     and z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  (z(8) and z(7) and z(6) and  not z(4) and  not z(3) and z(2) and  not z(1) and z(0))  or  ( not z(9) and z(7)
     and z(6) and  not z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and  not z(8) and z(7) and  not z(6)
     and z(4) and  not z(3) and z(2) and z(1) and z(0))  or  (z(8) and  not z(7) and z(6) and  not z(5) and  not z(4) and z(3) and  not z(2)
     and  not z(0))  or  ( not z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3)
     and z(2) and  not z(1) and  not z(0))  or  (z(7) and z(6) and  not z(5) and z(4) and  not z(3) and z(2) and z(1) and  not z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  (z(8) and  not z(7) and  not z(6)
     and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4)
     and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  (z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and z(1) and z(0))  or  ( not z(9) and  not z(7)
     and z(6) and z(5) and z(4) and z(3) and z(2) and z(1) and z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(4)
     and z(3) and  not z(2) and z(0))  or  ( not z(9) and z(7) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1) and z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(0))  or  ( not z(9) and z(8)
     and z(7) and z(6) and  not z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(8) and  not z(7) and z(6) and z(5)
     and  not z(4) and  not z(3) and  not z(2) and  not z(0))  or  ( not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and z(4) and z(3)
     and z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and  not z(1) and  not z(0))  or  (
     not z(9) and z(8) and  not z(7) and  not z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  ( not z(9) and  not z(8) and z(7)
     and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(0))  or  (z(8) and  not z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and z(2) and z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and  not z(1) and  not z(0))  or  (z(9)
     and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(1) and  not z(0))  or  ( not z(9) and  not z(8) and  not z(7) and z(6)
     and z(5) and z(4) and  not z(3) and z(2) and  not z(0))  or  ( not z(9) and z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(3)
     and z(2) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(1) and z(0))  or  (
    z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and  not z(1) and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6)
     and z(5) and z(3) and  not z(1) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(2) and  not z(0))  or  (
     not z(9) and  not z(8) and  not z(7) and z(6) and z(5) and  not z(4) and  not z(3) and z(2) and z(0))  or  ( not z(8) and z(7) and z(6)
     and z(5) and z(4) and z(3) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(2)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and  not z(3) and z(1) and  not z(0))  or  (z(9) and z(8)
     and z(7) and  not z(6) and  not z(5) and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(3) and z(1) and  not z(0))  or  (z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(1) and z(0))  or  (
     not z(8) and z(7) and z(6) and z(5) and  not z(4) and z(3) and z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and  not z(6)
     and  not z(5) and  not z(4) and z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and  not z(6) and  not z(5) and  not z(3) and z(1)
     and z(0))  or  (z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and z(1) and z(0))  or  (z(9) and z(8)
     and  not z(7) and  not z(6) and  not z(5) and z(4) and z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6) and  not z(5) and  not z(4)
     and  not z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6) and z(5) and z(4) and  not z(2) and  not z(0))  or  (
    z(9) and  not z(8) and z(7) and z(6) and  not z(5) and z(4) and  not z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6)
     and z(5) and  not z(4) and  not z(2) and  not z(0))  or  (z(9) and z(8) and z(7) and z(6) and z(5) and  not z(3) and  not z(1) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(2) and z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(5) and z(4) and z(2) and  not z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and  not z(2) and z(0))  or  (
    z(9) and  not z(8) and z(7) and  not z(6) and z(5) and  not z(4) and z(2) and  not z(0))  or  (z(9) and  not z(8) and z(7) and z(6)
     and  not z(5) and  not z(4) and z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and z(4) and z(2) and  not z(0))  or  (
    z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(1) and z(0))  or  (z(9) and  not z(8) and z(7) and  not z(6)
     and z(5) and z(4) and z(2) and z(0))  or  (z(9) and z(8) and  not z(7) and z(6) and z(5) and  not z(4) and z(2) and z(0))  or  (
    z(8) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(7) and z(6) and z(4)
     and z(3) and  not z(2) and  not z(1) and  not z(0))  or  (z(8) and z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and z(1)
     and  not z(0))  or  (z(7) and z(6) and z(5) and z(4) and  not z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and  not z(8)
     and  not z(7) and z(6) and  not z(5) and  not z(3) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5)
     and z(3) and  not z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  (
     not z(9) and z(8) and z(7) and  not z(6) and  not z(5) and z(3) and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7)
     and z(6) and  not z(5) and z(3) and  not z(2) and z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3)
     and z(2) and  not z(1))  or  ( not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and  not z(3) and  not z(2) and z(1))  or  (
     not z(9) and  not z(8) and  not z(7) and  not z(6) and z(5) and z(3) and z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and  not z(6)
     and  not z(5) and  not z(3) and z(2) and z(1))  or  ( not z(9) and z(8) and z(7) and z(6) and z(5) and z(3) and z(2) and z(1))  or  (
    z(9) and  not z(8) and  not z(6) and  not z(5) and  not z(3) and  not z(2))  or  (z(9) and  not z(8) and  not z(6) and  not z(5) and z(3)
     and z(2))  or  (z(9) and z(8) and z(6) and  not z(5) and z(3) and  not z(2))  or  (z(9) and z(8) and  not z(6) and z(5)
     and z(3) and  not z(2))  or  (z(9) and  not z(8) and z(6) and z(5) and  not z(3) and  not z(2))  or  (z(9) and z(8) and z(6)
     and  not z(5) and  not z(3) and z(2))  or  (z(9) and z(8) and  not z(6) and z(5) and  not z(3) and z(2))  or  (z(9) and  not z(8)
     and z(6) and z(5) and z(3) and z(2))  or  ( not z(9) and z(7) and  not z(6) and z(5) and  not z(4) and  not z(3) and  not z(2) and  not z(1)
     and  not z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and z(4) and  not z(3) and z(2) and  not z(1) and  not z(0))  or  (
     not z(9) and  not z(7) and z(6) and z(5) and z(4) and z(3) and  not z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and z(6)
     and  not z(5) and  not z(4) and z(3) and z(2) and z(1) and  not z(0))  or  ( not z(9) and z(7) and  not z(6) and z(5) and z(4) and  not z(3)
     and  not z(2) and  not z(1) and z(0))  or  ( not z(9) and  not z(7) and  not z(6) and  not z(5) and  not z(4) and  not z(3) and z(2) and  not z(1)
     and z(0))  or  ( not z(9) and  not z(7) and z(6) and z(5) and  not z(4) and z(3) and  not z(2) and z(1) and z(0))  or  ( not z(9)
     and z(7) and z(6) and  not z(5) and z(4) and z(3) and z(2) and z(1) and z(0));

					when others =>
						db <= (others => 'Z');
				end case;
			end if;
		end if;
	end process;

	control: process(clk)
	begin
		if (clk'event and clk = '1') then
			if (reset = '1') then
				ctrl <= (others => '0');
				cnt <= (others => '0');
			elsif (counter < "11111") then
				--cnt <= cnt + 1;
				ctrl(2) <= ( not counter(1) and  not counter(0))  or  ( not counter(2) and  not counter(1))  or  ( not counter(3) and  not counter(1))  or  ( not counter(4) and  not counter(1));
				ctrl(1) <= ( not counter(2));
				ctrl(0) <= (counter(4) and counter(3) and counter(2) and counter(1) and  not counter(0))  or  ( not counter(2) and counter(0))  or  ( not counter(3) and counter(0))  or  (not counter(4) and counter(0));
			else
				cnt <= (others => '0');
			end if;
		end if;
	end process;
end rtl;

